ros-kilted-rclcpp (29.5.2-1noble) noble; urgency=high

  * Shutdown deadlock fix jazzy (#2887 <https://github.com/ros2/rclcpp/issues/2887>) (#2888 <https://github.com/ros2/rclcpp/issues/2888>)
  * Fix test_publisher_with_system_default_qos (#2881 <https://github.com/ros2/rclcpp/issues/2881>) (#2884 <https://github.com/ros2/rclcpp/issues/2884>)
  * Contributors: Tomoya Fujita, Janosch Machowinski

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 07 Jul 2025 05:00:00 -0000

ros-kilted-rclcpp (29.5.1-1noble) noble; urgency=high

  * Removed warning test_qos (#2859 <https://github.com/ros2/rclcpp/issues/2859>) (#2873 <https://github.com/ros2/rclcpp/issues/2873>)
  * Fix for memory leaks in rclcpp::SerializedMessage (#2861 <https://github.com/ros2/rclcpp/issues/2861>) (#2863 <https://github.com/ros2/rclcpp/issues/2863>)
  * get_all_data_impl() does not handle null pointers properly, causing segmentation fault (backport #2840 <https://github.com/ros2/rclcpp/issues/2840>) (#2850 <https://github.com/ros2/rclcpp/issues/2850>)
  * Added missing chrono includes (#2854 <https://github.com/ros2/rclcpp/issues/2854>) (#2855 <https://github.com/ros2/rclcpp/issues/2855>)
  * QoSInitialization::from_rmw does not validate invalid history policy values, leading to silent failures (#2841 <https://github.com/ros2/rclcpp/issues/2841>) (#2846 <https://github.com/ros2/rclcpp/issues/2846>)
  * Add missing 's' to 'NodeParametersInterface' in doc/comment (#2831 <https://github.com/ros2/rclcpp/issues/2831>) (#2833 <https://github.com/ros2/rclcpp/issues/2833>)
  * subordinate node consistent behavior and update docstring. (#2822 <https://github.com/ros2/rclcpp/issues/2822>) (#2830 <https://github.com/ros2/rclcpp/issues/2830>)
  * throws std::invalid_argument if ParameterEvent is NULL. (#2814 <https://github.com/ros2/rclcpp/issues/2814>)
  * Removed clang warnings (#2823 <https://github.com/ros2/rclcpp/issues/2823>)
  * Contributors: Alejandro Hernández Cordero, Tomoya Fujita, mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 23 Jun 2025 05:00:00 -0000

ros-kilted-rclcpp (29.5.0-1noble) noble; urgency=high

  * Fix a race condition (#2819 <https://github.com/ros2/rclcpp/issues/2819>)
  * Remove redundant typesupport check in serialization module (#2808 <https://github.com/ros2/rclcpp/issues/2808>)
  * Remove get_typesupport_handle implementation. (#2806 <https://github.com/ros2/rclcpp/issues/2806>)
  * Use NodeParameterInterface instead of /parameter_event to update "use_sim_time" (#2378 <https://github.com/ros2/rclcpp/issues/2378>)
  * Remove cancel_clock_executor_promise_. (#2797 <https://github.com/ros2/rclcpp/issues/2797>)
  * Enable parameter update recursively only when QoS override parameters. (#2742 <https://github.com/ros2/rclcpp/issues/2742>)
  * Contributors: Pedro de Azeredo, Tanishq Chaudhary, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 18 Apr 2025 05:00:00 -0000

ros-kilted-rclcpp (29.4.0-1noble) noble; urgency=high

  * Removed trailing whitespace from the codebase. (#2791 <https://github.com/ros2/rclcpp/issues/2791>)
  * Expanded docstring of get_rmw_qos_profile() (#2787 <https://github.com/ros2/rclcpp/issues/2787>)
  * Set envars to run tests with rmw_zenoh_cpp with multicast discovery (#2776 <https://github.com/ros2/rclcpp/issues/2776>)
  * fix: Compilefix for clang (#2775 <https://github.com/ros2/rclcpp/issues/2775>)
  * add exception doc for configure_introspection. (#2773 <https://github.com/ros2/rclcpp/issues/2773>)
  * feat: Add ClockWaiter and ClockConditionalVariable (#2691 <https://github.com/ros2/rclcpp/issues/2691>)
  * doc: Added warning to not instantiate Clock directly with RCL_ROS_TIME (#2768 <https://github.com/ros2/rclcpp/issues/2768>)
  * Use rmw_event_type_is_supported in test_qos_event (#2761 <https://github.com/ros2/rclcpp/issues/2761>)
  * Support action typesupport helper (#2750 <https://github.com/ros2/rclcpp/issues/2750>)
  * use maybe_unused attribute for the portability. (#2758 <https://github.com/ros2/rclcpp/issues/2758>)
  * Executor strong reference fix (#2745 <https://github.com/ros2/rclcpp/issues/2745>)
  * Cleanup of https://github.com/ros2/rclcpp/pull/2683 (#2714 <https://github.com/ros2/rclcpp/issues/2714>)
  * Fix typo in doc section for get_service_typesupport_handle (#2751 <https://github.com/ros2/rclcpp/issues/2751>)
  * Test case and fix for for https://github.com/ros2/rclcpp/issues/2652 (#2713 <https://github.com/ros2/rclcpp/issues/2713>)
  * fix(timer): Delete node, after executor thread terminated (#2737 <https://github.com/ros2/rclcpp/issues/2737>)
  * update doc section for spin_xxx methods. (#2730 <https://github.com/ros2/rclcpp/issues/2730>)
  * fix: Expose timers used by rclcpp::Waitables (#2699 <https://github.com/ros2/rclcpp/issues/2699>)
  * use rmw_qos_profile_rosout_default instead of rcl. (#2663 <https://github.com/ros2/rclcpp/issues/2663>)
  * fix(Executor): Fixed entities not beeing executed after just beeing added (#2724 <https://github.com/ros2/rclcpp/issues/2724>)
  * fix: make the loop condition align with the description (#2726 <https://github.com/ros2/rclcpp/issues/2726>)
  * Collect log messages from rcl, and reset. (#2720 <https://github.com/ros2/rclcpp/issues/2720>)
  * Contributors: Abhishek Kashyap, Alejandro Hernández Cordero, Barry Xu, Janosch Machowinski, Leander Stephen D'Souza, Tomoya Fujita, Yuyuan Yuan

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 04 Apr 2025 05:00:00 -0000

ros-kilted-rclcpp (29.3.0-1noble) noble; urgency=high

  * Fix transient local IPC publish  (#2708 <https://github.com/ros2/rclcpp/issues/2708>)
  * apply actual QoS from rmw to the IPC publisher. (#2707 <https://github.com/ros2/rclcpp/issues/2707>)
  * Adding in topic name to logging on IPC issues (#2706 <https://github.com/ros2/rclcpp/issues/2706>)
  * fix TestTimeSource.ROS_time_valid_attach_detach. (#2700 <https://github.com/ros2/rclcpp/issues/2700>)
  * Update docstring for rclcpp::Node::now() (#2696 <https://github.com/ros2/rclcpp/issues/2696>)
  * Re-enable executor test on rmw_connextdds. (#2693 <https://github.com/ros2/rclcpp/issues/2693>)
  * Fix warnings on Windows. (#2692 <https://github.com/ros2/rclcpp/issues/2692>)
  * Omnibus fixes for running tests with Connext. (#2684 <https://github.com/ros2/rclcpp/issues/2684>)
  * fix(Executor): Fix segfault if callback group is deleted during rmw_wait (#2683 <https://github.com/ros2/rclcpp/issues/2683>)
  * Contributors: Chris Lalancette, Jeffery Hsu, Patrick Roncagliolo, Steve Macenski, Tomoya Fujita, jmachowinski

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 20 Dec 2024 06:00:00 -0000

ros-kilted-rclcpp (29.2.0-1noble) noble; urgency=high

  * accept custom allocator for LoanedMessage. (#2672 <https://github.com/ros2/rclcpp/issues/2672>)
  * Contributors: Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Nov 2024 06:00:00 -0000

ros-kilted-rclcpp (29.1.0-1noble) noble; urgency=high

  * a couple of typo fixes in doc section for LoanedMessage. (#2676 <https://github.com/ros2/rclcpp/issues/2676>)
  * Make sure callback_end tracepoint is triggered in AnyServiceCallback (#2670 <https://github.com/ros2/rclcpp/issues/2670>)
  * Correct the incorrect comments in generic_client.hpp (#2662 <https://github.com/ros2/rclcpp/issues/2662>)
  * Fix NodeOptions assignment operator (#2656 <https://github.com/ros2/rclcpp/issues/2656>)
  * set QoS History KEEP_ALL explicitly for statistics publisher. (#2650 <https://github.com/ros2/rclcpp/issues/2650>)
  * Fix test_intra_process_manager.cpp with rmw_zenoh_cpp (#2653 <https://github.com/ros2/rclcpp/issues/2653>)
  * Fixed test_events_executors in zenoh (#2643 <https://github.com/ros2/rclcpp/issues/2643>)
  * rmw_fastrtps supports service event gid uniqueness test. (#2638 <https://github.com/ros2/rclcpp/issues/2638>)
  * print warning if event callback is not supported instead of passing exception. (#2648 <https://github.com/ros2/rclcpp/issues/2648>)
  * Implement callback support of async_send_request for service generic client (#2614 <https://github.com/ros2/rclcpp/issues/2614>)
  * Contributors: Alejandro Hernández Cordero, Barry Xu, Chris Lalancette, Christophe Bedard, Romain DESILLE, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 20 Nov 2024 06:00:00 -0000

ros-kilted-rclcpp (29.0.0-1noble) noble; urgency=high

  * Fixed test qos rmw zenoh (#2639 <https://github.com/ros2/rclcpp/issues/2639>)
  * verify client gid uniqueness for a single service event. (#2636 <https://github.com/ros2/rclcpp/issues/2636>)
  * Skip some tests in test_qos_event and run others with event types supported by rmw_zenoh (#2626 <https://github.com/ros2/rclcpp/issues/2626>)
  * Shutdown the context before context's destructor is invoked in tests (#2633 <https://github.com/ros2/rclcpp/issues/2633>)
  * Skip rmw zenoh content filtering tests (#2627 <https://github.com/ros2/rclcpp/issues/2627>)
  * Use InvalidServiceTypeError for unavailable service type in GenericClient (#2629 <https://github.com/ros2/rclcpp/issues/2629>)
  * Implement generic service (#2617 <https://github.com/ros2/rclcpp/issues/2617>)
  * fix events-executor warm-up bug and add unit-tests (#2591 <https://github.com/ros2/rclcpp/issues/2591>)
  * remove unnecessary gtest-skip in test_executors (#2600 <https://github.com/ros2/rclcpp/issues/2600>)
  * Correct node name in service test code (#2615 <https://github.com/ros2/rclcpp/issues/2615>)
  * Minor naming fixes for ParameterValue to_string() function (#2609 <https://github.com/ros2/rclcpp/issues/2609>)
  * Removed clang warnings (#2605 <https://github.com/ros2/rclcpp/issues/2605>)
  * Fix a couple of issues in the documentation. (#2608 <https://github.com/ros2/rclcpp/issues/2608>)
  * deprecate the static single threaded executor (#2598 <https://github.com/ros2/rclcpp/issues/2598>)
  * Fix name of ParameterEventHandler class in doc (#2604 <https://github.com/ros2/rclcpp/issues/2604>)
  * subscriber_statistics_collectors_ should be protected by mutex. (#2592 <https://github.com/ros2/rclcpp/issues/2592>)
  * Fix bug in timers lifecycle for events executor (#2586 <https://github.com/ros2/rclcpp/issues/2586>)
  * fix rclcpp/test/rclcpp/CMakeLists.txt to check for the correct targets existance (#2596 <https://github.com/ros2/rclcpp/issues/2596>)
  * Shut down context during init if logging config fails (#2594 <https://github.com/ros2/rclcpp/issues/2594>)
  * Make more of the Waitable API abstract (#2593 <https://github.com/ros2/rclcpp/issues/2593>)
  * Contributors: Alberto Soragna, Alejandro Hernández Cordero, Alexis Pojomovsky, Barry Xu, Chris Lalancette, Christophe Bedard, Kang, Hsin-Yi, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 03 Oct 2024 05:00:00 -0000

ros-kilted-rclcpp (28.3.3-1noble) noble; urgency=high

  * Only compile the tests once. (#2590 <https://github.com/ros2/rclcpp/issues/2590>)
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 29 Jul 2024 05:00:00 -0000

ros-kilted-rclcpp (28.3.2-1noble) noble; urgency=high

  * Updated rcpputils path API (#2579 <https://github.com/ros2/rclcpp/issues/2579>)
  * Make the subscriber_triggered_to_receive_message test more reliable. (#2584 <https://github.com/ros2/rclcpp/issues/2584>)
    * Make the subscriber_triggered_to_receive_message test more reliable.
    In the current code, inside of the timer we create the subscription
    and the publisher, publish immediately, and expect the subscription
    to get it immediately.  But it may be the case that discovery
    hasn't even happened between the publisher and the subscription
    by the time the publish call happens.
    To make this more reliable, create the subscription and publish *before*
    we ever create and spin on the timer.  This at least gives 100
    milliseconds for discovery to happen.  That may not be quite enough
    to make this reliable on all platforms, but in my local testing this
    helps a lot.  Prior to this change I can make this fail one out of 10
    times, and after the change I've run 100 times with no failures.
  * Have the EventsExecutor use more common code  (#2570 <https://github.com/ros2/rclcpp/issues/2570>)
    * move notify waitable setup to its own function
    * move mutex lock to retrieve_entity utility
    * use entities_need_rebuild_ atomic bool in events-executors
    * remove duplicated set_on_ready_callback for notify_waitable
    * use mutex from base class rather than a new recursive mutex
    * use current_collection_ member in events-executor
    * delay adding notify waitable to collection
    * postpone clearing the current collection
    * commonize notify waitable and collection
    * commonize add/remove node/cbg methods
    * fix linter errors
    ---------
  * Removed deprecated methods and classes (#2575 <https://github.com/ros2/rclcpp/issues/2575>)
  * Release ownership of entities after spinning cancelled (#2556 <https://github.com/ros2/rclcpp/issues/2556>)
    * Release ownership of entities after spinning cancelled
    * Move release action to every exit point in different spin functions
    * Move wait_result_.reset() before setting spinning to false
    * Update test code
    * Move test code to test_executors.cpp
    ---------
  * Split test_executors.cpp even further. (#2572 <https://github.com/ros2/rclcpp/issues/2572>)
    That's because it is too large for Windows Debug to compile,
    so split into smaller bits.
    Even with this split, the file is too big; that's likely
    because we are using TYPED_TEST here, which generates multiple
    symbols per test case.  To deal with this, without further
    breaking up the file, also add in the /bigobj flag when
    compiling on Windows Debug.
  * avoid adding notify waitable twice to events-executor collection (#2564 <https://github.com/ros2/rclcpp/issues/2564>)
    * avoid adding notify waitable twice to events-executor entities collection
    * remove redundant mutex lock
    ---------
  * Contributors: Alberto Soragna, Alejandro Hernández Cordero, Barry Xu, Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 24 Jul 2024 05:00:00 -0000

ros-kilted-rclcpp (28.3.1-1noble) noble; urgency=high

  * Remove unnecessary msg includes in tests (#2566 <https://github.com/ros2/rclcpp/issues/2566>)
  * Fix copy-paste errors in function docs (#2565 <https://github.com/ros2/rclcpp/issues/2565>)
  * Fix typo in function doc (#2563 <https://github.com/ros2/rclcpp/issues/2563>)
  * Contributors: Christophe Bedard

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 25 Jun 2024 05:00:00 -0000

ros-kilted-rclcpp (28.3.0-1noble) noble; urgency=high

  * Add test creating two content filter topics with the same topic name (#2546 <https://github.com/ros2/rclcpp/issues/2546>) (#2549 <https://github.com/ros2/rclcpp/issues/2549>)
  * add impl pointer for ExecutorOptions (#2523 <https://github.com/ros2/rclcpp/issues/2523>)
  * Fixup Executor::spin_all() regression fix (#2517 <https://github.com/ros2/rclcpp/issues/2517>)
  * Add 'mimick' label to tests which use Mimick (#2516 <https://github.com/ros2/rclcpp/issues/2516>)
  * Contributors: Alejandro Hernández Cordero, Scott K Logan, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 17 Jun 2024 05:00:00 -0000

ros-kilted-rclcpp (28.2.0-1noble) noble; urgency=high

  * Check for negative time in rclcpp::Time(int64_t nanoseconds, ...) constructor (#2510 <https://github.com/ros2/rclcpp/issues/2510>)
  * Revise the description of service configure_introspection() (#2511 <https://github.com/ros2/rclcpp/issues/2511>)
  * Contributors: Barry Xu, Sharmin Ramli

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 26 Apr 2024 05:00:00 -0000

ros-kilted-rclcpp (28.1.0-1noble) noble; urgency=high

  * Remove references to index.ros.org. (#2504 <https://github.com/ros2/rclcpp/issues/2504>)
  * Reduce overhead for inheriting from rclcpp::Executor when base functionality is not reused (#2506 <https://github.com/ros2/rclcpp/issues/2506>)
  * Contributors: Chris Lalancette, William Woodall, jmachowinski

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 16 Apr 2024 05:00:00 -0000

ros-kilted-rclcpp (28.0.1-1noble) noble; urgency=high

  * [wjwwood] Updated "Data race fixes" (#2500 <https://github.com/ros2/rclcpp/issues/2500>)
    * Fix callback group logic in executor
    * fix: Fixed unnecessary copy of wait_set
    * fix(executor): Fixed race conditions with rebuild of wait_sets
    Before this change, the rebuild of wait set would be triggered
    after the wait set was waken up. With bad timing, this could
    lead to the rebuild not happening with multi threaded executor.
    * fix(Executor): Fixed lost of entities rebuild request
    * chore: Added assert for not set callback_group in execute_any_executable
    * Add test for cbg getting reset
    Co-authored-by: Janosch Machowinski <mailto:j.machowinski@nospam.org>
    * chore: renamed test cases to snake_case
    * style
    * fixup test to avoid polling and short timeouts
    * fix: Use correct notify_waitable_ instance
    * fix(StaticSingleThreadedExecutor): Added missing special case handling for current_notify_waitable_
    * fix(TestCallbackGroup): Fixed test after change to timers
    ---------
    Co-authored-by: Janosch Machowinski <mailto:j.machowinski@cellumation.com>
    Co-authored-by: Michael Carroll <mailto:mjcarroll@intrinsic.ai>
    Co-authored-by: Janosch Machowinski <mailto:j.machowinski@nospam.org>
  * fixup var names to snake case (#2501 <https://github.com/ros2/rclcpp/issues/2501>)
  * Added optional TimerInfo to timer callback (#2343 <https://github.com/ros2/rclcpp/issues/2343>)
    Co-authored-by: Alexis Tsogias <mailto:a.tsogias@cellumation.com>
    Co-authored-by: Janosch Machowinski <mailto:J.Machowinski@cellumation.com>
  * Fix uninitialized memory in test (#2498 <https://github.com/ros2/rclcpp/issues/2498>)
    When I added in the tests for large messages, I made a mistake and reserved space in the strings, but didn't actually expand it.  Thus, we were writing into uninitialized memory.  Fix this by just using the correct constructor for string, which will allocate and initialize the memory properly.
  * Ensure waitables handle guard condition retriggering (#2483 <https://github.com/ros2/rclcpp/issues/2483>)
    Co-authored-by: Michael Carroll <mailto:mjcarroll@intrinsic.ai>
  * fix: init concatenated_vector with begin() & end() (#2492 <https://github.com/ros2/rclcpp/issues/2492>)
    * this commit will fix the warning [-Wstringop-overflow=] #2461 <https://github.com/ros2/rclcpp/issues/2461>
  * Use the same context for the specified node in rclcpp::spin functions (#2433 <https://github.com/ros2/rclcpp/issues/2433>)
    * Use the same conext for the specified node in rclcpp::spin_xx functions
    * Add test for spinning with non-default-context
    * Format code
    ---------
  * Disable compare-function-pointers in test_utilities (#2489 <https://github.com/ros2/rclcpp/issues/2489>)
  * address ambiguous auto variable. (#2481 <https://github.com/ros2/rclcpp/issues/2481>)
  * Increase the cppcheck timeout to 1200 seconds (#2484 <https://github.com/ros2/rclcpp/issues/2484>)
  * Removed test_timers_manager clang warning (#2479 <https://github.com/ros2/rclcpp/issues/2479>)
  * Flaky timer test fix (#2469 <https://github.com/ros2/rclcpp/issues/2469>)
    * fix(time_source): Fixed possible race condition
    * fix(test_executors_time_cancel_behaviour): Fixed multiple race conditions
    ---------
    Co-authored-by: Janosch Machowinski <mailto:j.machowinski@nospam.org>
  * Add tracepoint for generic publisher/subscriber (#2448 <https://github.com/ros2/rclcpp/issues/2448>)
  * update rclcpp::Waitable API to use references and const (#2467 <https://github.com/ros2/rclcpp/issues/2467>)
  * Utilize rclcpp::WaitSet as part of the executors (#2142 <https://github.com/ros2/rclcpp/issues/2142>)
    * Deprecate callback_group call taking context
    * Add base executor objects that can be used by implementors
    * Template common operations
    * Address reviewer feedback:
    * Add callback to EntitiesCollector constructor
    * Make function to check automatically added callback groups take a list
    * Lint
    * Address reviewer feedback and fix templates
    * Lint and docs
    * Make executor own the notify waitable
    * Add pending queue to collector, remove from waitable
    Also change node's get_guard_condition to return shared_ptr
    * Change interrupt guard condition to shared_ptr
    Check if guard condition is valid before adding it to the waitable
    * Lint and docs
    * Utilize rclcpp::WaitSet as part of the executors
    * Don't exchange atomic twice
    * Fix add_node and add more tests
    * Make get_notify_guard_condition follow API tick-tock
    * Improve callback group tick-tocking
    * Don't lock twice
    * Address reviewer feedback
    * Add thread safety annotations and make locks consistent
    * @wip
    * Reset callback groups for multithreaded executor
    * Avoid many small function calls when building executables
    * Re-trigger guard condition if buffer has data
    * Address reviewer feedback
    * Trace points
    * Remove tracepoints
    * Reducing diff
    * Reduce diff
    * Uncrustify
    * Restore tests
    * Back to weak_ptr and reduce test time
    * reduce diff and lint
    * Restore static single threaded tests that weren't working before
    * Restore more tests
    * Fix multithreaded test
    * Fix assert
    * Fix constructor test
    * Change ready_executables signature back
    * Don't enforce removing callback groups before nodes
    * Remove the "add_valid_node" API
    * Only notify if the trigger condition is valid
    * Only trigger if valid and needed
    * Fix spin_some/spin_all implementation
    * Restore single threaded executor
    * Picking ABI-incompatible executor changes
    * Add PIMPL
    * Additional waitset prune
    * Fix bad merge
    * Expand test timeout
    * Introduce method to clear expired entities from a collection
    * Make sure to call remove_expired_entities().
    * Prune queued work when callback group is removed
    * Prune subscriptions from dynamic storage
    * Styles fixes.
    * Re-trigger guard conditions
    * Condense to just use watiable.take_data
    * Lint
    * Address reviewer comments (nits)
    * Lock mutex when copying
    * Refactors to static single threaded based on reviewers
    * More small refactoring
    * Lint
    * Lint
    * Add ready executable accessors to WaitResult
    * Make use of accessors from wait_set
    * Fix tests
    * Fix more tests
    * Tidy up single threaded executor implementation
    * Don't null out timer, rely on call
    * change how timers are checked from wait result in executors
    * peak -> peek
    * fix bug in next_waitable logic
    * fix bug in StaticSTE that broke the add callback groups to executor tests
    * style
    ---------
    Co-authored-by: Chris Lalancette <clalancette@gmail.com>
    Co-authored-by: William Woodall <william@osrfoundation.org>
  * fix flakiness in TestTimersManager unit-test (#2468 <https://github.com/ros2/rclcpp/issues/2468>)
    the previous version of the test was relying on the assumption that a timer with 1ms period gets called at least 6 times if the main thread waits 15ms. this is true most of the times, but it's not guaranteed, especially when running the test on windows CI servers. the new version of the test makes no assumptions on how much time it takes for the timers manager to invoke the timers, but rather focuses on ensuring that they are called the right amount of times, which is what's important for the purpose of the test
  * Contributors: Alberto Soragna, Alejandro Hernández Cordero, Chris Lalancette, Homalozoa X, Kotaro Yoshimoto, Michael Carroll, Tomoya Fujita, William Woodall, h-suzuki-isp, jmachowinski

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 16 Apr 2024 05:00:00 -0000

ros-kilted-rclcpp (28.0.0-1noble) noble; urgency=high

  * fix spin_some_max_duration unit-test for events-executor (#2465 <https://github.com/ros2/rclcpp/issues/2465>)
  * refactor and improve the parameterized spin_some tests for executors (#2460 <https://github.com/ros2/rclcpp/issues/2460>)
    * refactor and improve the spin_some parameterized tests for executors
    * disable spin_some_max_duration for the StaticSingleThreadedExecutor and EventsExecutor
    * fixup and clarify the docstring for Executor::spin_some()
    * style
    * review comments
    ---------
  * enable simulation clock for timer canceling test. (#2458 <https://github.com/ros2/rclcpp/issues/2458>)
    * enable simulation clock for timer canceling test.
    * move MainExecutorTypes to test_executors_timer_cancel_behavior.cpp.
    ---------
  * Revert "relax the test simulation rate for timer canceling tests. (#2453 <https://github.com/ros2/rclcpp/issues/2453>)" (#2456 <https://github.com/ros2/rclcpp/issues/2456>)
    This reverts commit 1c350d0d7fb9c7158e0a39057112486ddbd38e9a.
  * relax the test simulation rate for timer canceling tests. (#2453 <https://github.com/ros2/rclcpp/issues/2453>)
  * Fix TypeAdapted publishing with large messages. (#2443 <https://github.com/ros2/rclcpp/issues/2443>)
    Mostly by ensuring we aren't attempting to store
    large messages on the stack.  Also add in tests.
    I verified that before these changes, the tests failed,
    while after them they succeed.
  * Implement generic client (#2358 <https://github.com/ros2/rclcpp/issues/2358>)
    * Implement generic client
    * Fix the incorrect parameter declaration
    * Deleted copy constructor and assignment for FutureAndRequestId
    * Update codes after rebase
    * Address review comments
    * Address review comments from iuhilnehc-ynos
    * Correct an error in a description
    * Fix window build errors
    * Address review comments from William
    * Add doc strings to create_generic_client
    ---------
  * Rule of five: implement move operators (#2425 <https://github.com/ros2/rclcpp/issues/2425>)
  * Various cleanups to deal with uncrustify 0.78. (#2439 <https://github.com/ros2/rclcpp/issues/2439>)
    These should also work with uncrustify 0.72.
  * Remove the set_deprecated signatures in any_subscription_callback. (#2431 <https://github.com/ros2/rclcpp/issues/2431>)
    These have been deprecated since April 2021, so it is safe
    to remove them now.
  * fix doxygen syntax for NodeInterfaces (#2428 <https://github.com/ros2/rclcpp/issues/2428>)
  * Set hints to find the python version we actually want. (#2426 <https://github.com/ros2/rclcpp/issues/2426>)
    The comment in the commit explains the reasoning behind it.
  * Update quality declaration documents (#2427 <https://github.com/ros2/rclcpp/issues/2427>)
  * feat: add/minus for msg::Time and rclcpp::Duration (#2419 <https://github.com/ros2/rclcpp/issues/2419>)
    * feat: add/minus for msg::Time and rclcpp::Duration
  * Contributors: Alberto Soragna, Barry Xu, Chris Lalancette, Christophe Bedard, HuaTsai, Jonas Otto, Tim Clephas, Tomoya Fujita, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 28 Mar 2024 05:00:00 -0000

ros-kilted-rclcpp (27.0.0-1noble) noble; urgency=high

  * Split test_executors up into smaller chunks. (#2421 <https://github.com/ros2/rclcpp/issues/2421>)
  * [events executor] - Fix Behavior with Timer Cancel (#2375 <https://github.com/ros2/rclcpp/issues/2375>)
  * Removed deprecated header (#2413 <https://github.com/ros2/rclcpp/issues/2413>)
  * Make sure to mark RingBuffer methods as 'override'. (#2410 <https://github.com/ros2/rclcpp/issues/2410>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Matt Condino

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 07 Feb 2024 06:00:00 -0000

ros-kilted-rclcpp (26.0.0-1noble) noble; urgency=high

  * Increase the cppcheck timeout to 600 seconds. (#2409 <https://github.com/ros2/rclcpp/issues/2409>)
  * Add transient local durability support to publisher and subscriptions when using intra-process communication (#2303 <https://github.com/ros2/rclcpp/issues/2303>)
  * Stop storing the context in the guard condition. (#2400 <https://github.com/ros2/rclcpp/issues/2400>)
  * Contributors: Chris Lalancette, Jeffery Hsu

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 24 Jan 2024 06:00:00 -0000

ros-kilted-rclcpp (25.0.0-1noble) noble; urgency=high

  * Updated GenericSubscription to AnySubscriptionCallback (#1928 <https://github.com/ros2/rclcpp/issues/1928>)
  * make type support helper supported for service (#2209 <https://github.com/ros2/rclcpp/issues/2209>)
  * Adding QoS to subscription options (#2323 <https://github.com/ros2/rclcpp/issues/2323>)
  * Switch to target_link_libraries. (#2374 <https://github.com/ros2/rclcpp/issues/2374>)
  * aligh with rcl that a rosout publisher of a node might not exist (#2357 <https://github.com/ros2/rclcpp/issues/2357>)
  * Fix data race in EventHandlerBase (#2349 <https://github.com/ros2/rclcpp/issues/2349>)
  * Support users holding onto shared pointers in the message memory pool (#2336 <https://github.com/ros2/rclcpp/issues/2336>)
  * Contributors: Chen Lihui, Chris Lalancette, DensoADAS, Lucas Wendland, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 26 Dec 2023 06:00:00 -0000

ros-kilted-rclcpp (24.0.0-1noble) noble; urgency=high

  * fix (signal_handler.hpp): spelling (#2356 <https://github.com/ros2/rclcpp/issues/2356>)
  * Updates to not use std::move in some places. (#2353 <https://github.com/ros2/rclcpp/issues/2353>)
  * rclcpp::Time::max() clock type support. (#2352 <https://github.com/ros2/rclcpp/issues/2352>)
  * Serialized Messages with Topic Statistics (#2274 <https://github.com/ros2/rclcpp/issues/2274>)
  * Add a custom deleter when constructing rcl_service_t (#2351 <https://github.com/ros2/rclcpp/issues/2351>)
  * Disable the loaned messages inside the executor. (#2335 <https://github.com/ros2/rclcpp/issues/2335>)
  * Use message_info in SubscriptionTopicStatistics instead of typed message (#2337 <https://github.com/ros2/rclcpp/issues/2337>)
  * Add missing 'enable_rosout' comments (#2345 <https://github.com/ros2/rclcpp/issues/2345>)
  * Adjust rclcpp usage of type description service (#2344 <https://github.com/ros2/rclcpp/issues/2344>)
  * address rate related flaky tests. (#2329 <https://github.com/ros2/rclcpp/issues/2329>)
  * Fixes pointed out by the clang analyzer. (#2339 <https://github.com/ros2/rclcpp/issues/2339>)
  * Remove useless ROSRate class (#2326 <https://github.com/ros2/rclcpp/issues/2326>)
  * Contributors: Alexey Merzlyakov, Chris Lalancette, Jiaqi Li, Lucas Wendland, Michael Carroll, Michael Orlov, Tomoya Fujita, Zard-C

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 06 Nov 2023 06:00:00 -0000

ros-kilted-rclcpp (23.2.0-1noble) noble; urgency=high

  * add clients & services count (#2072 <https://github.com/ros2/rclcpp/issues/2072>)
  * remove invalid sized allocation test for SerializedMessage. (#2330 <https://github.com/ros2/rclcpp/issues/2330>)
  * Adding API to copy all parameters from one node to another (#2304 <https://github.com/ros2/rclcpp/issues/2304>)
  * Contributors: Minju, Lee, Steve Macenski, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 09 Oct 2023 05:00:00 -0000

ros-kilted-rclcpp (23.1.0-1noble) noble; urgency=high

  * Add locking to protect the TimeSource::NodeState::node_base_ (#2320 <https://github.com/ros2/rclcpp/issues/2320>)
  * Update SignalHandler get_global_signal_handler to avoid complex types in static memory (#2316 <https://github.com/ros2/rclcpp/issues/2316>)
  * Removing Old Connext Tests (#2313 <https://github.com/ros2/rclcpp/issues/2313>)
  * Documentation for list_parameters  (#2315 <https://github.com/ros2/rclcpp/issues/2315>)
  * Decouple rosout publisher init from node init. (#2174 <https://github.com/ros2/rclcpp/issues/2174>)
  * fix the depth to relative in list_parameters (#2300 <https://github.com/ros2/rclcpp/issues/2300>)
  * Contributors: Chris Lalancette, Lucas Wendland, Minju, Lee, Tomoya Fujita, Tully Foote

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 04 Oct 2023 05:00:00 -0000

ros-kilted-rclcpp (23.0.0-1noble) noble; urgency=high

  * Fix the return type of Rate::period. (#2301 <https://github.com/ros2/rclcpp/issues/2301>)
  * Update API docs links in package READMEs (#2302 <https://github.com/ros2/rclcpp/issues/2302>)
  * Cleanup flaky timers_manager tests. (#2299 <https://github.com/ros2/rclcpp/issues/2299>)
  * Contributors: Chris Lalancette, Christophe Bedard

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 08 Sep 2023 05:00:00 -0000

ros-kilted-rclcpp (22.2.0-1noble) noble; urgency=high

  * Topic correct typeadapter deduction (#2294 <https://github.com/ros2/rclcpp/issues/2294>)
  * Fix C++20 allocator construct deprecation (#2292 <https://github.com/ros2/rclcpp/issues/2292>)
  * Make Rate to select the clock to work with (#2123 <https://github.com/ros2/rclcpp/issues/2123>)
  * Correct the position of a comment. (#2290 <https://github.com/ros2/rclcpp/issues/2290>)
  * Remove unnecessary lambda captures in the tests. (#2289 <https://github.com/ros2/rclcpp/issues/2289>)
  * Add rcl_logging_interface as an explicit dependency. (#2284 <https://github.com/ros2/rclcpp/issues/2284>)
  * Revamp list_parameters to be more efficient and easier to read. (#2282 <https://github.com/ros2/rclcpp/issues/2282>)
  * Contributors: AiVerisimilitude, Alexey Merzlyakov, Chen Lihui, Chris Lalancette, Jiaqi Li

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 07 Sep 2023 05:00:00 -0000

ros-kilted-rclcpp (22.1.0-1noble) noble; urgency=high

  * Do not crash Executor when send_response fails due to client failure. (#2276 <https://github.com/ros2/rclcpp/issues/2276>)
  * Adding Custom Unknown Type Error (#2272 <https://github.com/ros2/rclcpp/issues/2272>)
  * Add a pimpl inside rclcpp::Node for future distro backports (#2228 <https://github.com/ros2/rclcpp/issues/2228>)
  * Remove an unused variable from the events executor tests. (#2270 <https://github.com/ros2/rclcpp/issues/2270>)
  * Add spin_all shortcut (#2246 <https://github.com/ros2/rclcpp/issues/2246>)
  * Adding Missing Group Exceptions (#2256 <https://github.com/ros2/rclcpp/issues/2256>)
  * Change associated clocks storage to unordered_set (#2257 <https://github.com/ros2/rclcpp/issues/2257>)
  * associated clocks should be protected by mutex. (#2255 <https://github.com/ros2/rclcpp/issues/2255>)
  * Instrument loaned message publication code path (#2240 <https://github.com/ros2/rclcpp/issues/2240>)
  * Contributors: Chris Lalancette, Christophe Bedard, Emerson Knapp, Luca Della Vedova, Lucas Wendland, Tomoya Fujita, Tony Najjar

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 21 Aug 2023 05:00:00 -0000

ros-kilted-rclcpp (22.0.0-1noble) noble; urgency=high

  * Implement get_node_type_descriptions_interface for lifecyclenode and add smoke test for it (#2237 <https://github.com/ros2/rclcpp/issues/2237>)
  * Add new node interface TypeDescriptionsInterface to provide GetTypeDescription service (#2224 <https://github.com/ros2/rclcpp/issues/2224>)
  * Move always_false_v to detail namespace (#2232 <https://github.com/ros2/rclcpp/issues/2232>)
  * Revamp the test_subscription.cpp tests. (#2227 <https://github.com/ros2/rclcpp/issues/2227>)
  * warning: comparison of integer expressions of different signedness (#2219 <https://github.com/ros2/rclcpp/issues/2219>)
  * Modifies timers API to select autostart state (#2005 <https://github.com/ros2/rclcpp/issues/2005>)
  * Enable callback group tests for connextdds (#2182 <https://github.com/ros2/rclcpp/issues/2182>)
  * Contributors: Chris Lalancette, Christopher Wecht, Eloy Briceno, Emerson Knapp, Nathan Wiebe Neufeldt, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 11 Jul 2023 05:00:00 -0000

ros-kilted-rclcpp (21.3.0-1noble) noble; urgency=high

  * Fix up misspellings of "receive". (#2208 <https://github.com/ros2/rclcpp/issues/2208>)
  * Remove flaky stressAddRemoveNode test (#2206 <https://github.com/ros2/rclcpp/issues/2206>)
  * Use TRACETOOLS_ prefix for tracepoint-related macros (#2162 <https://github.com/ros2/rclcpp/issues/2162>)
  * Contributors: Chris Lalancette, Christophe Bedard, Michael Carroll

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Jun 2023 05:00:00 -0000

ros-kilted-rclcpp (21.2.0-1noble) noble; urgency=high

  * remove nolint since ament_cpplint updated for the c++17 header (#2198 <https://github.com/ros2/rclcpp/issues/2198>)
  * Feature/available capacity of ipm (#2173 <https://github.com/ros2/rclcpp/issues/2173>)
  * add mutex to protect events_executor current entity collection (#2187 <https://github.com/ros2/rclcpp/issues/2187>)
  * Declare rclcpp callbacks before the rcl entities (#2024 <https://github.com/ros2/rclcpp/issues/2024>)
  * Contributors: Alberto Soragna, Chen Lihui, DensoADAS, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 07 Jun 2023 05:00:00 -0000

ros-kilted-rclcpp (21.1.1-1noble) noble; urgency=high

  * Fix race condition in events-executor (#2177 <https://github.com/ros2/rclcpp/issues/2177>)
  * Add missing stdexcept include (#2186 <https://github.com/ros2/rclcpp/issues/2186>)
  * Fix a format-security warning when building with clang (#2171 <https://github.com/ros2/rclcpp/issues/2171>)
  * Fix delivered message kind (#2175 <https://github.com/ros2/rclcpp/issues/2175>)
  * Contributors: Alberto Soragna, Chris Lalancette, methylDragon, Øystein Sture

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 11 May 2023 05:00:00 -0000

ros-kilted-rclcpp (21.1.0-1noble) noble; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 27 Apr 2023 05:00:00 -0000

ros-kilted-rclcpp (21.0.0-1noble) noble; urgency=high

  * Add support for logging service. (#2122 <https://github.com/ros2/rclcpp/issues/2122>)
  * Picking ABI-incompatible executor changes (#2170 <https://github.com/ros2/rclcpp/issues/2170>)
  * add events-executor and timers-manager in rclcpp (#2155 <https://github.com/ros2/rclcpp/issues/2155>)
  * Create common structures for executors to use (#2143 <https://github.com/ros2/rclcpp/issues/2143>)
  * Implement deliver message kind (#2168 <https://github.com/ros2/rclcpp/issues/2168>)
  * Contributors: Alberto Soragna, Lei Liu, Michael Carroll, methylDragon

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 18 Apr 2023 05:00:00 -0000

ros-kilted-rclcpp (20.0.0-1noble) noble; urgency=high

  * applied tracepoints for ring_buffer (#2091 <https://github.com/ros2/rclcpp/issues/2091>)
  * Dynamic Subscription (REP-2011 Subset): Stubs for rclcpp (#2165 <https://github.com/ros2/rclcpp/issues/2165>)
  * Add type_hash to cpp TopicEndpointInfo (#2137 <https://github.com/ros2/rclcpp/issues/2137>)
  * Trigger the intraprocess guard condition with data (#2164 <https://github.com/ros2/rclcpp/issues/2164>)
  * Minor grammar fix (#2149 <https://github.com/ros2/rclcpp/issues/2149>)
  * Fix unnecessary allocations in executor.cpp (#2135 <https://github.com/ros2/rclcpp/issues/2135>)
  * add Logger::get_effective_level(). (#2141 <https://github.com/ros2/rclcpp/issues/2141>)
  * Remove deprecated header (#2139 <https://github.com/ros2/rclcpp/issues/2139>)
  * Implement matched event (#2105 <https://github.com/ros2/rclcpp/issues/2105>)
  * use allocator via init_options argument. (#2129 <https://github.com/ros2/rclcpp/issues/2129>)
  * Fixes to silence some clang warnings. (#2127 <https://github.com/ros2/rclcpp/issues/2127>)
  * Documentation improvements on the executor (#2125 <https://github.com/ros2/rclcpp/issues/2125>)
  * Avoid losing waitable handles while using MultiThreadedExecutor (#2109 <https://github.com/ros2/rclcpp/issues/2109>)
  * Hook up the incompatible type event inside of rclcpp (#2069 <https://github.com/ros2/rclcpp/issues/2069>)
  * Update all rclcpp packages to C++17. (#2121 <https://github.com/ros2/rclcpp/issues/2121>)
  * Fix clang warning: bugprone-use-after-move (#2116 <https://github.com/ros2/rclcpp/issues/2116>)
  * Contributors: Barry Xu, Chris Lalancette, Christopher Wecht, Emerson Knapp, Michael Carroll, Tomoya Fujita, Yadu, mauropasse, methylDragon, ymski

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 13 Apr 2023 05:00:00 -0000

ros-kilted-rclcpp (19.3.0-1noble) noble; urgency=high

  * Fix memory leak in tracetools::get_symbol() (#2104 <https://github.com/ros2/rclcpp/issues/2104>)
  * Service introspection (#1985 <https://github.com/ros2/rclcpp/issues/1985>)
  * Allow publishing borrowed messages with intra-process enabled (#2108 <https://github.com/ros2/rclcpp/issues/2108>)
  * to fix flaky test about TestTimeSource.callbacks (#2111 <https://github.com/ros2/rclcpp/issues/2111>)
  * Contributors: Brian, Chen Lihui, Christophe Bedard, Miguel Company

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 01 Mar 2023 06:00:00 -0000

ros-kilted-rclcpp (19.2.0-1noble) noble; urgency=high

  * to create a sublogger while getting child of Logger (#1717 <https://github.com/ros2/rclcpp/issues/1717>)
  * Fix documentation of Context class (#2107 <https://github.com/ros2/rclcpp/issues/2107>)
  * fixes for rmw callbacks in qos_event class (#2102 <https://github.com/ros2/rclcpp/issues/2102>)
  * Contributors: Alberto Soragna, Chen Lihui, Silvio Traversaro

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 24 Feb 2023 06:00:00 -0000

ros-kilted-rclcpp (19.1.0-1noble) noble; urgency=high

  * Add support for timers on reset callback (#1979 <https://github.com/ros2/rclcpp/issues/1979>)
  * Topic node guard condition in executor (#2074 <https://github.com/ros2/rclcpp/issues/2074>)
  * Fix bug on the disorder of calling shutdown callback (#2097 <https://github.com/ros2/rclcpp/issues/2097>)
  * Contributors: Barry Xu, Chen Lihui, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 14 Feb 2023 06:00:00 -0000

ros-kilted-rclcpp (19.0.0-1noble) noble; urgency=high

  * Add default constructor to NodeInterfaces (#2094 <https://github.com/ros2/rclcpp/issues/2094>)
  * Fix clock state cached time to be a copy, not a reference. (#2092 <https://github.com/ros2/rclcpp/issues/2092>)
  * Fix -Wmaybe-uninitialized warning (#2081 <https://github.com/ros2/rclcpp/issues/2081>)
  * Fix the keep_last warning when using system defaults. (#2082 <https://github.com/ros2/rclcpp/issues/2082>)
  * Add in a fix for older compilers. (#2075 <https://github.com/ros2/rclcpp/issues/2075>)
  * Contributors: Alexander Hans, Chris Lalancette, Shane Loretz

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 30 Jan 2023 06:00:00 -0000

ros-kilted-rclcpp (18.0.0-1noble) noble; urgency=high

  * Implement Unified Node Interface (NodeInterfaces class) (#2041 <https://github.com/ros2/rclcpp/issues/2041>)
  * Do not throw exception if trying to dequeue an empty intra-process buffer (#2061 <https://github.com/ros2/rclcpp/issues/2061>)
  * Move event callback binding to PublisherBase and SubscriptionBase (#2066 <https://github.com/ros2/rclcpp/issues/2066>)
  * Implement validity checks for rclcpp::Clock (#2040 <https://github.com/ros2/rclcpp/issues/2040>)
  * Explicitly set callback type (#2059 <https://github.com/ros2/rclcpp/issues/2059>)
  * Fix logging macros to build with msvc and cpp20 (#2063 <https://github.com/ros2/rclcpp/issues/2063>)
  * Add clock type to node_options (#1982 <https://github.com/ros2/rclcpp/issues/1982>)
  * Fix nullptr dereference in prune_requests_older_than (#2008 <https://github.com/ros2/rclcpp/issues/2008>)
  * Remove templating on to_rcl_subscription_options (#2056 <https://github.com/ros2/rclcpp/issues/2056>)
  * Fix SharedFuture from async_send_request never becoming valid (#2044 <https://github.com/ros2/rclcpp/issues/2044>)
  * Add in a warning for a KeepLast depth of 0. (#2048 <https://github.com/ros2/rclcpp/issues/2048>)
  * Mark rclcpp::Clock::now() as const (#2050 <https://github.com/ros2/rclcpp/issues/2050>)
  * Fix a case that did not throw ParameterUninitializedException (#2036 <https://github.com/ros2/rclcpp/issues/2036>)
  * Update maintainers (#2043 <https://github.com/ros2/rclcpp/issues/2043>)
  * Contributors: Alberto Soragna, Audrow Nash, Chen Lihui, Chris Lalancette, Jeffery Hsu, Lei Liu, Mateusz Szczygielski, Shane Loretz, andrei, mauropasse, methylDragon

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 29 Dec 2022 06:00:00 -0000

ros-kilted-rclcpp (17.1.0-1noble) noble; urgency=high

  * MultiThreadExecutor number of threads is at least 2+ in default. (#2032 <https://github.com/ros2/rclcpp/issues/2032>)
  * Fix bug that a callback not reached (#1640 <https://github.com/ros2/rclcpp/issues/1640>)
  * Set the minimum number of threads of the Multithreaded executor to 2 (#2030 <https://github.com/ros2/rclcpp/issues/2030>)
  * check thread whether joinable before join (#2019 <https://github.com/ros2/rclcpp/issues/2019>)
  * Set cpplint test timeout to 3 minutes (#2022 <https://github.com/ros2/rclcpp/issues/2022>)
  * Make sure to include-what-you-use in the node_interfaces. (#2018 <https://github.com/ros2/rclcpp/issues/2018>)
  * Do not clear entities callbacks on destruction (#2002 <https://github.com/ros2/rclcpp/issues/2002>)
  * fix mismatched issue if using zero_allocate (#1995 <https://github.com/ros2/rclcpp/issues/1995>)
  * Contributors: Alexis Paques, Chen Lihui, Chris Lalancette, Cristóbal Arroyo, Tomoya Fujita, mauropasse, uupks

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 02 Nov 2022 05:00:00 -0000

ros-kilted-rclcpp (17.0.0-1noble) noble; urgency=high

  * Make ParameterService and Sync/AsyncParameterClient accept rclcpp::QoS (#1978 <https://github.com/ros2/rclcpp/issues/1978>)
  * support regex match for parameter client (#1992 <https://github.com/ros2/rclcpp/issues/1992>)
  * operator+= and operator-= for Duration (#1988 <https://github.com/ros2/rclcpp/issues/1988>)
  * Revert "Revert "Add a create_timer method to Node and LifecycleNode classes (#1975 <https://github.com/ros2/rclcpp/issues/1975>)" (#2009 <https://github.com/ros2/rclcpp/issues/2009>) (#2010 <https://github.com/ros2/rclcpp/issues/2010>)
  * force compiler warning if callback handles not captured (#2000 <https://github.com/ros2/rclcpp/issues/2000>)
  * Revert "Add a create_timer method to Node and LifecycleNode classes (#1975 <https://github.com/ros2/rclcpp/issues/1975>)" (#2009 <https://github.com/ros2/rclcpp/issues/2009>)
  * Add a create_timer method to Node and LifecycleNode classes (#1975 <https://github.com/ros2/rclcpp/issues/1975>)
  * [docs] add note about callback lifetime for {on, post}_set_parameter_callback (#1981 <https://github.com/ros2/rclcpp/issues/1981>)
  * fix memory leak (#1994 <https://github.com/ros2/rclcpp/issues/1994>)
  * Support pre-set and post-set parameter callbacks in addition to on-set-parameter-callback. (#1947 <https://github.com/ros2/rclcpp/issues/1947>)
  * Make create_service accept rclcpp::QoS (#1969 <https://github.com/ros2/rclcpp/issues/1969>)
  * Make create_client accept rclcpp::QoS (#1964 <https://github.com/ros2/rclcpp/issues/1964>)
  * Fix the documentation for rclcpp::ok to be accurate. (#1965 <https://github.com/ros2/rclcpp/issues/1965>)
  * use regex for wildcard matching (#1839 <https://github.com/ros2/rclcpp/issues/1839>)
  * Revert "Introduce executors new spin_for method, replace spin_until_future_complete with spin_until_complete. (#1821 <https://github.com/ros2/rclcpp/issues/1821>) (#1874 <https://github.com/ros2/rclcpp/issues/1874>)" (#1956 <https://github.com/ros2/rclcpp/issues/1956>)
  * Introduce executors new spin_for method, replace spin_until_future_complete with spin_until_complete. (#1821 <https://github.com/ros2/rclcpp/issues/1821>) (#1874 <https://github.com/ros2/rclcpp/issues/1874>)
  * test adjustment for LoanedMessage. (#1951 <https://github.com/ros2/rclcpp/issues/1951>)
  * fix virtual dispatch issues identified by clang-tidy (#1816 <https://github.com/ros2/rclcpp/issues/1816>)
  * Remove unused on_parameters_set_callback_ (#1945 <https://github.com/ros2/rclcpp/issues/1945>)
  * Fix subscription.is_serialized() for callbacks with message info (#1950 <https://github.com/ros2/rclcpp/issues/1950>)
  * wait for subscriptions on another thread. (#1940 <https://github.com/ros2/rclcpp/issues/1940>)
  * Fix documentation of RCLCPP_[INFO,WARN,...] (#1943 <https://github.com/ros2/rclcpp/issues/1943>)
  * Always trigger guard condition waitset (#1923 <https://github.com/ros2/rclcpp/issues/1923>)
  * Add statistics for handle_loaned_message (#1927 <https://github.com/ros2/rclcpp/issues/1927>)
  * Drop wrong template specialization (#1926 <https://github.com/ros2/rclcpp/issues/1926>)
  * Contributors: Alberto Soragna, Andrew Symington, Barry Xu, Brian, Chen Lihui, Chris Lalancette, Daniel Reuter, Deepanshu Bansal, Hubert Liberacki, Ivan Santiago Paunovic, Jochen Sprickerhof, Nikolai Morin, Shane Loretz, Tomoya Fujita, Tyler Weaver, William Woodall, schrodinbug

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 13 Sep 2022 05:00:00 -0000

ros-kilted-rclcpp (16.2.0-1noble) noble; urgency=high

  * Update get_parameter_from_event to follow the function description (#1922 <https://github.com/ros2/rclcpp/issues/1922>)
  * Add 'best available' QoS enum values and methods (#1920 <https://github.com/ros2/rclcpp/issues/1920>)
  * Contributors: Barry Xu, Jacob Perron

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 03 May 2022 05:00:00 -0000

ros-kilted-rclcpp (16.1.0-1noble) noble; urgency=high

  * use reinterpret_cast for function pointer conversion. (#1919 <https://github.com/ros2/rclcpp/issues/1919>)
  * Contributors: Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 29 Apr 2022 05:00:00 -0000

ros-kilted-rclcpp (16.0.1-1noble) noble; urgency=high

  * remove DEFINE_CONTENT_FILTER cmake option (#1914 <https://github.com/ros2/rclcpp/issues/1914>)
  * Contributors: Chen Lihui

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 13 Apr 2022 05:00:00 -0000

ros-kilted-rclcpp (16.0.0-1noble) noble; urgency=high

  * remove things that were deprecated during galactic (#1913 <https://github.com/ros2/rclcpp/issues/1913>)
  * Contributors: William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 08 Apr 2022 05:00:00 -0000

ros-kilted-rclcpp (15.4.0-1noble) noble; urgency=high

  * add take_data_by_entity_id API to waitable (#1892 <https://github.com/ros2/rclcpp/issues/1892>)
  * add content-filtered-topic interfaces (#1561 <https://github.com/ros2/rclcpp/issues/1561>)
  * Contributors: Alberto Soragna, Chen Lihui

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 05 Apr 2022 05:00:00 -0000

ros-kilted-rclcpp (15.3.0-1noble) noble; urgency=high

  * [NodeParameters] Set name in param info pre-check (#1908 <https://github.com/ros2/rclcpp/issues/1908>)
  * Add test-dep ament_cmake_google_benchmark (#1904 <https://github.com/ros2/rclcpp/issues/1904>)
  * Add publish by loaned message in GenericPublisher (#1856 <https://github.com/ros2/rclcpp/issues/1856>)
  * Contributors: Abrar Rahman Protyasha, Barry Xu, Gaël Écorchard

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 30 Mar 2022 05:00:00 -0000

ros-kilted-rclcpp (15.2.0-1noble) noble; urgency=high

  * Add missing ament dependency on rcl_interfaces (#1903 <https://github.com/ros2/rclcpp/issues/1903>)
  * Update data callback tests to account for all published samples (#1900 <https://github.com/ros2/rclcpp/issues/1900>)
  * Increase timeout for acknowledgments to account for slower Connext settings (#1901 <https://github.com/ros2/rclcpp/issues/1901>)
  * clang-tidy: explicit constructors (#1782 <https://github.com/ros2/rclcpp/issues/1782>)
  * Add client/service QoS getters (#1784 <https://github.com/ros2/rclcpp/issues/1784>)
  * Fix a bunch more rosdoc2 issues in rclcpp. (#1897 <https://github.com/ros2/rclcpp/issues/1897>)
  * time_until_trigger returns max time if timer is cancelled (#1893 <https://github.com/ros2/rclcpp/issues/1893>)
  * Micro-optimizations in rclcpp (#1896 <https://github.com/ros2/rclcpp/issues/1896>)
  * Contributors: Andrea Sorbini, Chris Lalancette, Mauro Passerino, Scott K Logan, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 24 Mar 2022 05:00:00 -0000

ros-kilted-rclcpp (15.1.0-1noble) noble; urgency=high

  * spin_all with a zero timeout. (#1878 <https://github.com/ros2/rclcpp/issues/1878>)
  * Add RMW listener APIs (#1579 <https://github.com/ros2/rclcpp/issues/1579>)
  * Remove fastrtps customization on tests (#1887 <https://github.com/ros2/rclcpp/issues/1887>)
  * Install headers to include/${PROJECT_NAME} (#1888 <https://github.com/ros2/rclcpp/issues/1888>)
  * Use ament_generate_version_header (#1886 <https://github.com/ros2/rclcpp/issues/1886>)
  * use universal reference to support rvalue. (#1883 <https://github.com/ros2/rclcpp/issues/1883>)
  * fix one subscription can wait_for_message twice (#1870 <https://github.com/ros2/rclcpp/issues/1870>)
  * Add return value version of get_parameter_or (#1813 <https://github.com/ros2/rclcpp/issues/1813>)
  * Cleanup time source object lifetimes (#1867 <https://github.com/ros2/rclcpp/issues/1867>)
  * add is_spinning() method to executor base class
  * Contributors: Alberto Soragna, Chen Lihui, Chris Lalancette, Kenji Miyake, Miguel Company, Shane Loretz, Tomoya Fujita, iRobot ROS

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 01 Mar 2022 06:00:00 -0000

ros-kilted-rclcpp (15.0.0-1noble) noble; urgency=high

  * Cleanup the TypeAdapt tests (#1858 <https://github.com/ros2/rclcpp/issues/1858>)
  * Cleanup includes (#1857 <https://github.com/ros2/rclcpp/issues/1857>)
  * Fix include order and relative paths for cpplint (#1859 <https://github.com/ros2/rclcpp/issues/1859>)
  * Rename stringstream in macros to a more unique name (#1862 <https://github.com/ros2/rclcpp/issues/1862>)
  * Add non transform capabilities for intra-process (#1849 <https://github.com/ros2/rclcpp/issues/1849>)
  * Fix rclcpp documentation build (#1779 <https://github.com/ros2/rclcpp/issues/1779>)
  * Contributors: Chris Lalancette, Doug Smith, Gonzo, Jacob Perron, Michel Hidalgo

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 14 Jan 2022 06:00:00 -0000

ros-kilted-rclcpp (14.1.0-1noble) noble; urgency=high

  * Use UninitializedStaticallyTypedParameterException (#1689 <https://github.com/ros2/rclcpp/issues/1689>)
  * Add wait_for_all_acked support (#1662 <https://github.com/ros2/rclcpp/issues/1662>)
  * Add tests for function templates of declare_parameter (#1747 <https://github.com/ros2/rclcpp/issues/1747>)
  * Contributors: Barry Xu, Bi0T1N, M. Mostafa Farzan

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 05 Jan 2022 06:00:00 -0000

ros-kilted-rclcpp (14.0.0-1noble) noble; urgency=high

  * Fixes for uncrustify 0.72 (#1844 <https://github.com/ros2/rclcpp/issues/1844>)
  * use private member to keep the all reference underneath. (#1845 <https://github.com/ros2/rclcpp/issues/1845>)
  * Make node base sharable (#1832 <https://github.com/ros2/rclcpp/issues/1832>)
  * Add Clock::sleep_for() (#1828 <https://github.com/ros2/rclcpp/issues/1828>)
  * Synchronize rcl and std::chrono steady clocks in Clock::sleep_until (#1830 <https://github.com/ros2/rclcpp/issues/1830>)
  * Use rclcpp::guard_condition (#1612 <https://github.com/ros2/rclcpp/issues/1612>)
  * Call CMake function to generate version header (#1805 <https://github.com/ros2/rclcpp/issues/1805>)
  * Use parantheses around logging macro parameter (#1820 <https://github.com/ros2/rclcpp/issues/1820>)
  * Remove author by request (#1818 <https://github.com/ros2/rclcpp/issues/1818>)
  * Update maintainers (#1817 <https://github.com/ros2/rclcpp/issues/1817>)
  * min_forward & min_backward thresholds must not be disabled (#1815 <https://github.com/ros2/rclcpp/issues/1815>)
  * Re-add Clock::sleep_until (#1814 <https://github.com/ros2/rclcpp/issues/1814>)
  * Fix lifetime of context so it remains alive while its dependent node handles are still in use (#1754 <https://github.com/ros2/rclcpp/issues/1754>)
  * Add the interface for pre-shutdown callback (#1714 <https://github.com/ros2/rclcpp/issues/1714>)
  * Take message ownership from moved LoanedMessage (#1808 <https://github.com/ros2/rclcpp/issues/1808>)
  * Suppress clang dead-store warnings in the benchmarks. (#1802 <https://github.com/ros2/rclcpp/issues/1802>)
  * Wait for publisher and subscription to match (#1777 <https://github.com/ros2/rclcpp/issues/1777>)
  * Fix unused QoS profile for clock subscription and make ClockQoS the default (#1801 <https://github.com/ros2/rclcpp/issues/1801>)
  * Contributors: Abrar Rahman Protyasha, Barry Xu, Chen Lihui, Chris Lalancette, Grey, Jacob Perron, Nikolai Morin, Shane Loretz, Tomoya Fujita, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 17 Dec 2021 06:00:00 -0000

ros-kilted-rclcpp (13.1.0-1noble) noble; urgency=high

  * Fix dangerous std::bind capture in TimeSource implementation. (#1768 <https://github.com/ros2/rclcpp/issues/1768>)
  * Fix dangerous std::bind capture in ParameterEventHandler implementation. (#1770 <https://github.com/ros2/rclcpp/issues/1770>)
  * Handle sigterm, in the same way sigint is being handled. (#1771 <https://github.com/ros2/rclcpp/issues/1771>)
  * rclcpp::Node copy constructor: make copy of node_waitables_ member. (#1799 <https://github.com/ros2/rclcpp/issues/1799>)
  * Extend NodeGraph to match what rcl provides. (#1484 <https://github.com/ros2/rclcpp/issues/1484>)
  * Context::sleep_for(): replace recursion with do-while to avoid potential stack-overflow. (#1765 <https://github.com/ros2/rclcpp/issues/1765>)
  * extend_sub_namespace(): Verify string::empty() before calling string::front(). (#1764 <https://github.com/ros2/rclcpp/issues/1764>)
  * Deprecate the void shared_ptr<MessageT> subscription callback signatures. (#1713 <https://github.com/ros2/rclcpp/issues/1713>)
  * Contributors: Abrar Rahman Protyasha, Chris Lalancette, Emerson Knapp, Geoffrey Biggs, Ivan Santiago Paunovic, Jorge Perez, Tomoya Fujita, William Woodall, Yong-Hao Zou, livanov93

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 18 Oct 2021 05:00:00 -0000

ros-kilted-rclcpp (13.0.0-1noble) noble; urgency=high

  * Remove can_be_nullptr assignment check for QNX case. (#1752 <https://github.com/ros2/rclcpp/issues/1752>)
  * Update client API to be able to remove pending requests. (#1734 <https://github.com/ros2/rclcpp/issues/1734>)
  * Fix: Allow to add a node while spinning in the StaticSingleThreadedExecutor. (#1690 <https://github.com/ros2/rclcpp/issues/1690>)
  * Add tracing instrumentation for executor and message taking. (#1738 <https://github.com/ros2/rclcpp/issues/1738>)
  * Fix: Reset timer trigger time before execute in StaticSingleThreadedExecutor. (#1739 <https://github.com/ros2/rclcpp/issues/1739>)
  * Use FindPython3 and make python3 dependency explicit. (#1745 <https://github.com/ros2/rclcpp/issues/1745>)
  * Use rosidl_get_typesupport_target(). (#1729 <https://github.com/ros2/rclcpp/issues/1729>)
  * Fix returning invalid namespace if sub_namespace is empty. (#1658 <https://github.com/ros2/rclcpp/issues/1658>)
  * Add free function to wait for a subscription message. (#1705 <https://github.com/ros2/rclcpp/issues/1705>)
  * Use rcpputils/scope_exit.hpp and remove rclcpp/scope_exit.hpp. (#1727 <https://github.com/ros2/rclcpp/issues/1727>)
  * Contributors: Ahmed Sobhy, Christophe Bedard, Ivan Santiago Paunovic, Karsten Knese, M. Hofstätter, Mauro Passerino, Shane Loretz, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 23 Aug 2021 05:00:00 -0000

ros-kilted-rclcpp (12.0.0-1noble) noble; urgency=high

  * Remove unsafe get_callback_groups API.
    Callers should change to using for_each_callback_group(), or
    store the callback groups they need internally.
  * Add in callback_groups_for_each.
    The main reason to add this method in is to make accesses to the
    callback_groups_ vector thread-safe.  By having a
    callback_groups_for_each that accepts a std::function, we can
    just have the callers give us the callback they are interested
    in, and we can take care of the locking.
    The rest of this fairly large PR is cleaning up all of the places
    that use get_callback_groups() to instead use
    callback_groups_for_each().
  * Use a different mechanism to avoid timers being scheduled multiple times by the MultiThreadedExecutor (#1692 <https://github.com/ros2/rclcpp/issues/1692>)
  * Fix windows CI (#1726 <https://github.com/ros2/rclcpp/issues/1726>)
    Fix bug in AnyServiceCallback introduced in #1709 <https://github.com/ros2/rclcpp/issues/1709>.
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 26 Jul 2021 05:00:00 -0000

ros-kilted-rclcpp (11.2.0-1noble) noble; urgency=high

  * Support to defer to send a response in services. (#1709 <https://github.com/ros2/rclcpp/issues/1709>)
    Signed-off-by: Ivan Santiago Paunovic <mailto:ivanpauno@ekumenlabs.com>
  * Fix documentation bug. (#1719 <https://github.com/ros2/rclcpp/issues/1719>)
    Signed-off-by: William Woodall <mailto:william@osrfoundation.org>
  * Contributors: Ivan Santiago Paunovic, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 21 Jul 2021 05:00:00 -0000

ros-kilted-rclcpp (11.1.0-1noble) noble; urgency=high

  * Removed left over ``is_initialized()`` implementation (#1711 <https://github.com/ros2/rclcpp/issues/1711>)
    Leftover from https://github.com/ros2/rclcpp/pull/1622
  * Fixed declare parameter methods for int and float vectors (#1696 <https://github.com/ros2/rclcpp/issues/1696>)
  * Cleaned up implementation of the intra-process manager (#1695 <https://github.com/ros2/rclcpp/issues/1695>)
  * Added the node name to an executor ``runtime_error`` (#1686 <https://github.com/ros2/rclcpp/issues/1686>)
  * Fixed a typo "Attack" -> "Attach" (#1687 <https://github.com/ros2/rclcpp/issues/1687>)
  * Removed use of std::allocator<>::rebind (#1678 <https://github.com/ros2/rclcpp/issues/1678>)
    rebind is deprecated in c++17 and removed in c++20
  * Contributors: Alberto Soragna, Chen Lihui, Chris Lalancette, Petter Nilsson, Steve Macenski, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 13 Jul 2021 05:00:00 -0000

ros-kilted-rclcpp (11.0.0-1noble) noble; urgency=high

  * Allow declare uninitialized parameters (#1673 <https://github.com/ros2/rclcpp/issues/1673>)
  * Fix syntax issue with gcc (#1674 <https://github.com/ros2/rclcpp/issues/1674>)
  * [service] Don't use a weak_ptr to avoid leaking (#1668 <https://github.com/ros2/rclcpp/issues/1668>)
  * Contributors: Ivan Santiago Paunovic, Jacob Perron, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 18 May 2021 05:00:00 -0000

ros-kilted-rclcpp (10.0.0-1noble) noble; urgency=high

  * Fix doc typo (#1663 <https://github.com/ros2/rclcpp/issues/1663>)
  * [rclcpp] Type Adaptation feature (#1557 <https://github.com/ros2/rclcpp/issues/1557>)
  * Do not attempt to use void allocators for memory allocation. (#1657 <https://github.com/ros2/rclcpp/issues/1657>)
  * Keep custom allocator in publisher and subscription options alive. (#1647 <https://github.com/ros2/rclcpp/issues/1647>)
  * Fix get_publishers_subscriptions_info_by_topic test in test_node.cpp (#1648 <https://github.com/ros2/rclcpp/issues/1648>)
  * Use OnShutdown callback handle instead of OnShutdown callback (#1639 <https://github.com/ros2/rclcpp/issues/1639>)
  * use dynamic_pointer_cast to detect allocator mismatch in intra process manager (#1643 <https://github.com/ros2/rclcpp/issues/1643>)
  * Increase cppcheck timeout to 500s (#1634 <https://github.com/ros2/rclcpp/issues/1634>)
  * Clarify node parameters docs (#1631 <https://github.com/ros2/rclcpp/issues/1631>)
  * Contributors: Audrow Nash, Barry Xu, Jacob Perron, Michel Hidalgo, Shane Loretz, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 11 May 2021 05:00:00 -0000

ros-kilted-rclcpp (9.0.2-1noble) noble; urgency=high

  * Avoid returning loan when none was obtained. (#1629 <https://github.com/ros2/rclcpp/issues/1629>)
  * Use a different implementation of mutex two priorities (#1628 <https://github.com/ros2/rclcpp/issues/1628>)
  * Do not test the value of the history policy when testing the get_publishers/subscriptions_info_by_topic() methods (#1626 <https://github.com/ros2/rclcpp/issues/1626>)
  * Check first parameter type and range before calling the user validation callbacks (#1627 <https://github.com/ros2/rclcpp/issues/1627>)
  * Contributors: Ivan Santiago Paunovic, Miguel Company

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 14 Apr 2021 05:00:00 -0000

ros-kilted-rclcpp (9.0.1-1noble) noble; urgency=high

  * Restore test exception for Connext (#1625 <https://github.com/ros2/rclcpp/issues/1625>)
  * Fix race condition in TimeSource clock thread setup (#1623 <https://github.com/ros2/rclcpp/issues/1623>)
  * Contributors: Andrea Sorbini, Michel Hidalgo

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Apr 2021 05:00:00 -0000

ros-kilted-rclcpp (9.0.0-1noble) noble; urgency=high

  * remove deprecated code which was deprecated in foxy and should be removed in galactic (#1622 <https://github.com/ros2/rclcpp/issues/1622>)
  * Change index.ros.org -> docs.ros.org. (#1620 <https://github.com/ros2/rclcpp/issues/1620>)
  * Unique network flows (#1496 <https://github.com/ros2/rclcpp/issues/1496>)
  * Add spin_some support to the StaticSingleThreadedExecutor (#1338 <https://github.com/ros2/rclcpp/issues/1338>)
  * Add publishing instrumentation (#1600 <https://github.com/ros2/rclcpp/issues/1600>)
  * Create load_parameters and delete_parameters methods (#1596 <https://github.com/ros2/rclcpp/issues/1596>)
  * refactor AnySubscriptionCallback and add/deprecate callback signatures (#1598 <https://github.com/ros2/rclcpp/issues/1598>)
  * Add generic publisher and generic subscription for serialized messages (#1452 <https://github.com/ros2/rclcpp/issues/1452>)
  * use context from node_base_ for clock executor. (#1617 <https://github.com/ros2/rclcpp/issues/1617>)
  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#1615 <https://github.com/ros2/rclcpp/issues/1615>)
  * Contributors: Ananya Muddukrishna, BriceRenaudeau, Chris Lalancette, Christophe Bedard, Nikolai Morin, Tomoya Fujita, William Woodall, mauropasse, shonigmann

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 06 Apr 2021 05:00:00 -0000

ros-kilted-rclcpp (8.2.0-1noble) noble; urgency=high

  * Initialize integers in test_parameter_event_handler.cpp to avoid undefined behavior (#1609 <https://github.com/ros2/rclcpp/issues/1609>)
  * Namespace tracetools C++ functions (#1608 <https://github.com/ros2/rclcpp/issues/1608>)
  * Revert "Namespace tracetools C++ functions (#1603 <https://github.com/ros2/rclcpp/issues/1603>)" (#1607 <https://github.com/ros2/rclcpp/issues/1607>)
  * Namespace tracetools C++ functions (#1603 <https://github.com/ros2/rclcpp/issues/1603>)
  * Clock subscription callback group spins in its own thread (#1556 <https://github.com/ros2/rclcpp/issues/1556>)
  * Contributors: Chris Lalancette, Christophe Bedard, Ivan Santiago Paunovic, anaelle-sw

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 31 Mar 2021 05:00:00 -0000

ros-kilted-rclcpp (8.1.0-1noble) noble; urgency=high

  * Remove rmw_connext_cpp references. (#1595 <https://github.com/ros2/rclcpp/issues/1595>)
  * Add API for checking QoS profile compatibility (#1554 <https://github.com/ros2/rclcpp/issues/1554>)
  * Document misuse of parameters callback (#1590 <https://github.com/ros2/rclcpp/issues/1590>)
  * use const auto & to iterate over parameters (#1593 <https://github.com/ros2/rclcpp/issues/1593>)
  * Contributors: Chris Lalancette, Jacob Perron, Karsten Knese

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 25 Mar 2021 05:00:00 -0000

ros-kilted-rclcpp (8.0.0-1noble) noble; urgency=high

  * Guard against integer overflow in duration conversion (#1584 <https://github.com/ros2/rclcpp/issues/1584>)
  * Contributors: Jacob Perron

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 23 Mar 2021 05:00:00 -0000

ros-kilted-rclcpp (7.0.1-1noble) noble; urgency=high

  * get_parameters service should return empty if undeclared parameters are allowed (#1514 <https://github.com/ros2/rclcpp/issues/1514>)
  * Made 'Context::shutdown_reason' function a const function (#1578 <https://github.com/ros2/rclcpp/issues/1578>)
  * Contributors: Tomoya Fujita, suab321321

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 22 Mar 2021 05:00:00 -0000

ros-kilted-rclcpp (7.0.0-1noble) noble; urgency=high

  * Document design decisions that were made for statically typed parameters (#1568 <https://github.com/ros2/rclcpp/issues/1568>)
  * Fix doc typo in CallbackGroup constructor (#1582 <https://github.com/ros2/rclcpp/issues/1582>)
  * Enable qos parameter overrides for the /parameter_events topic  (#1532 <https://github.com/ros2/rclcpp/issues/1532>)
  * Add support for rmw_connextdds (#1574 <https://github.com/ros2/rclcpp/issues/1574>)
  * Remove 'struct' from the rcl_time_jump_t. (#1577 <https://github.com/ros2/rclcpp/issues/1577>)
  * Add tests for declaring statically typed parameters when undeclared parameters are allowed (#1575 <https://github.com/ros2/rclcpp/issues/1575>)
  * Quiet clang memory leak warning on "DoNotOptimize". (#1571 <https://github.com/ros2/rclcpp/issues/1571>)
  * Add ParameterEventsSubscriber class (#829 <https://github.com/ros2/rclcpp/issues/829>)
  * When a parameter change is rejected, the parameters map shouldn't be updated. (#1567 <https://github.com/ros2/rclcpp/pull/1567>)
  * Fix when to throw the NoParameterOverrideProvided exception. (#1567 <https://github.com/ros2/rclcpp/pull/1567>)
  * Fix SEGV caused by order of destruction of Node sub-interfaces (#1469 <https://github.com/ros2/rclcpp/issues/1469>)
  * Fix benchmark test failure introduced in #1522 <https://github.com/ros2/rclcpp/issues/1522> (#1564 <https://github.com/ros2/rclcpp/issues/1564>)
  * Fix documented example in create_publisher (#1558 <https://github.com/ros2/rclcpp/issues/1558>)
  * Enforce static parameter types (#1522 <https://github.com/ros2/rclcpp/issues/1522>)
  * Allow timers to keep up the intended rate in MultiThreadedExecutor (#1516 <https://github.com/ros2/rclcpp/issues/1516>)
  * Fix UBSAN warnings in any_subscription_callback. (#1551 <https://github.com/ros2/rclcpp/issues/1551>)
  * Fix runtime error: reference binding to null pointer of type (#1547 <https://github.com/ros2/rclcpp/issues/1547>)
  * Contributors: Andrea Sorbini, Chris Lalancette, Colin MacKenzie, Ivan Santiago Paunovic, Jacob Perron, Steven! Ragnarök, bpwilcox, tomoya

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 18 Mar 2021 05:00:00 -0000

ros-kilted-rclcpp (6.3.1-1noble) noble; urgency=high

  * Reference test resources directly from source tree (#1543 <https://github.com/ros2/rclcpp/issues/1543>)
  * clear statistics after window reset (#1531 <https://github.com/ros2/rclcpp/issues/1531>) (#1535 <https://github.com/ros2/rclcpp/issues/1535>)
  * Fix a minor string error in the topic_statistics test. (#1541 <https://github.com/ros2/rclcpp/issues/1541>)
  * Avoid Resource deadlock avoided if use intra_process_comms (#1530 <https://github.com/ros2/rclcpp/issues/1530>)
  * Avoid an object copy in parameter_value.cpp. (#1538 <https://github.com/ros2/rclcpp/issues/1538>)
  * Assert that the publisher_list size is 1. (#1537 <https://github.com/ros2/rclcpp/issues/1537>)
  * Don't access objects after they have been std::move (#1536 <https://github.com/ros2/rclcpp/issues/1536>)
  * Update for checking correct variable (#1534 <https://github.com/ros2/rclcpp/issues/1534>)
  * Destroy msg extracted from LoanedMessage. (#1305 <https://github.com/ros2/rclcpp/issues/1305>)
  * Contributors: Chen Lihui, Chris Lalancette, Ivan Santiago Paunovic, Miaofei Mei, Scott K Logan, William Woodall, hsgwa

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 08 Feb 2021 06:00:00 -0000

ros-kilted-rclcpp (6.3.0-1noble) noble; urgency=high

  * Add instrumentation for linking a timer to a node (#1500 <https://github.com/ros2/rclcpp/issues/1500>)
  * Fix error when using IPC with StaticSingleThreadExecutor (#1520 <https://github.com/ros2/rclcpp/issues/1520>)
  * Change to using unique_ptrs for DummyExecutor. (#1517 <https://github.com/ros2/rclcpp/issues/1517>)
  * Allow reconfiguring 'clock' topic qos (#1512 <https://github.com/ros2/rclcpp/issues/1512>)
  * Allow to add/remove nodes thread safely in rclcpp::Executor  (#1505 <https://github.com/ros2/rclcpp/issues/1505>)
  * Call rclcpp::shutdown in test_node for clean shutdown on Windows (#1515 <https://github.com/ros2/rclcpp/issues/1515>)
  * Reapply "Add get_logging_directory method to rclcpp::Logger (#1509 <https://github.com/ros2/rclcpp/issues/1509>)" (#1513 <https://github.com/ros2/rclcpp/issues/1513>)
  * use describe_parameters of parameter client for test (#1499 <https://github.com/ros2/rclcpp/issues/1499>)
  * Revert "Add get_logging_directory method to rclcpp::Logger (#1509 <https://github.com/ros2/rclcpp/issues/1509>)" (#1511 <https://github.com/ros2/rclcpp/issues/1511>)
  * Add get_logging_directory method to rclcpp::Logger (#1509 <https://github.com/ros2/rclcpp/issues/1509>)
  * Contributors: Chris Lalancette, Christophe Bedard, Ivan Santiago Paunovic, eboasson, mauropasse, tomoya

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Jan 2021 06:00:00 -0000

ros-kilted-rclcpp (6.2.0-1noble) noble; urgency=high

  * Better documentation for the QoS class (#1508 <https://github.com/ros2/rclcpp/issues/1508>)
  * Modify excluding callback duration from topic statistics (#1492 <https://github.com/ros2/rclcpp/issues/1492>)
  * Make the test of graph users more robust. (#1504 <https://github.com/ros2/rclcpp/issues/1504>)
  * Make sure to wait for graph change events in test_node_graph. (#1503 <https://github.com/ros2/rclcpp/issues/1503>)
  * add timeout to SyncParametersClient methods (#1493 <https://github.com/ros2/rclcpp/issues/1493>)
  * Fix wrong test expectations (#1497 <https://github.com/ros2/rclcpp/issues/1497>)
  * Update create_publisher/subscription documentation, clarifying when a parameters interface is required (#1494 <https://github.com/ros2/rclcpp/issues/1494>)
  * Fix string literal warnings (#1442 <https://github.com/ros2/rclcpp/issues/1442>)
  * support describe_parameters methods to parameter client. (#1453 <https://github.com/ros2/rclcpp/issues/1453>)
  * Contributors: Audrow Nash, Chris Lalancette, Ivan Santiago Paunovic, Nikolai Morin, hsgwa, tomoya

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 08 Jan 2021 06:00:00 -0000

ros-kilted-rclcpp (6.1.0-1noble) noble; urgency=high

  * Add getters to rclcpp::qos and rclcpp::Policy enum classes (#1467 <https://github.com/ros2/rclcpp/issues/1467>)
  * Change nullptr checks to use ASSERT_TRUE. (#1486 <https://github.com/ros2/rclcpp/issues/1486>)
  * Adjust logic around finding and erasing guard_condition (#1474 <https://github.com/ros2/rclcpp/issues/1474>)
  * Update QDs to QL 1 (#1477 <https://github.com/ros2/rclcpp/issues/1477>)
  * Add performance tests for parameter transport (#1463 <https://github.com/ros2/rclcpp/issues/1463>)
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic, Scott K Logan, Stephen Brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 10 Dec 2020 06:00:00 -0000

ros-kilted-rclcpp (6.0.0-1noble) noble; urgency=high

  * Move ownership of shutdown_guard_condition to executors/graph_listener (#1404 <https://github.com/ros2/rclcpp/issues/1404>)
  * Add options to automatically declare qos parameters when creating a publisher/subscription (#1465 <https://github.com/ros2/rclcpp/issues/1465>)
  * Add take_data to Waitable and data to AnyExecutable (#1241 <https://github.com/ros2/rclcpp/issues/1241>)
  * Add benchmarks for node parameters interface (#1444 <https://github.com/ros2/rclcpp/issues/1444>)
  * Remove allocation from executor::remove_node() (#1448 <https://github.com/ros2/rclcpp/issues/1448>)
  * Fix test crashes on CentOS 7 (#1449 <https://github.com/ros2/rclcpp/issues/1449>)
  * Bump rclcpp packages to Quality Level 2 (#1445 <https://github.com/ros2/rclcpp/issues/1445>)
  * Added executor benchmark tests (#1413 <https://github.com/ros2/rclcpp/issues/1413>)
  * Add fully-qualified namespace to WeakCallbackGroupsToNodesMap (#1435 <https://github.com/ros2/rclcpp/issues/1435>)
  * Contributors: Alejandro Hernández Cordero, Audrow Nash, Chris Lalancette, Ivan Santiago Paunovic, Louise Poubel, Scott K Logan, brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 18 Nov 2020 06:00:00 -0000

ros-kilted-rclcpp (5.1.0-1noble) noble; urgency=high

  * Deprecate Duration(rcl_duration_value_t) in favor of static Duration::from_nanoseconds(rcl_duration_value_t) (#1432 <https://github.com/ros2/rclcpp/issues/1432>)
  * Avoid parsing arguments twice in rclcpp::init_and_remove_ros_arguments (#1415 <https://github.com/ros2/rclcpp/issues/1415>)
  * Add service and client benchmarks (#1425 <https://github.com/ros2/rclcpp/issues/1425>)
  * Set CMakeLists to only use default rmw for benchmarks (#1427 <https://github.com/ros2/rclcpp/issues/1427>)
  * Update tracetools' QL in rclcpp's QD (#1428 <https://github.com/ros2/rclcpp/issues/1428>)
  * Add missing locking to the rclcpp_action::ServerBase. (#1421 <https://github.com/ros2/rclcpp/issues/1421>)
  * Initial benchmark tests for rclcpp::init/shutdown create/destroy node (#1411 <https://github.com/ros2/rclcpp/issues/1411>)
  * Refactor test CMakeLists in prep for benchmarks (#1422 <https://github.com/ros2/rclcpp/issues/1422>)
  * Add methods in topic and service interface to resolve a name (#1410 <https://github.com/ros2/rclcpp/issues/1410>)
  * Update deprecated gtest macros (#1370 <https://github.com/ros2/rclcpp/issues/1370>)
  * Clear members for StaticExecutorEntitiesCollector to avoid shared_ptr dependency (#1303 <https://github.com/ros2/rclcpp/issues/1303>)
  * Increase test timeouts of slow running tests with rmw_connext_cpp (#1400 <https://github.com/ros2/rclcpp/issues/1400>)
  * Avoid self dependency that not destoryed (#1301 <https://github.com/ros2/rclcpp/issues/1301>)
  * Update maintainers (#1384 <https://github.com/ros2/rclcpp/issues/1384>)
  * Add clock qos to node options (#1375 <https://github.com/ros2/rclcpp/issues/1375>)
  * Fix NodeOptions copy constructor (#1376 <https://github.com/ros2/rclcpp/issues/1376>)
  * Make sure to clean the external client/service handle. (#1296 <https://github.com/ros2/rclcpp/issues/1296>)
  * Increase coverage of WaitSetTemplate (#1368 <https://github.com/ros2/rclcpp/issues/1368>)
  * Increase coverage of guard_condition.cpp to 100% (#1369 <https://github.com/ros2/rclcpp/issues/1369>)
  * Add coverage statement (#1367 <https://github.com/ros2/rclcpp/issues/1367>)
  * Tests for LoanedMessage with mocked loaned message publisher (#1366 <https://github.com/ros2/rclcpp/issues/1366>)
  * Add unit tests for qos and qos_event files (#1352 <https://github.com/ros2/rclcpp/issues/1352>)
  * Finish coverage of publisher API (#1365 <https://github.com/ros2/rclcpp/issues/1365>)
  * Finish API coverage on executors. (#1364 <https://github.com/ros2/rclcpp/issues/1364>)
  * Add test for ParameterService (#1355 <https://github.com/ros2/rclcpp/issues/1355>)
  * Add time API coverage tests (#1347 <https://github.com/ros2/rclcpp/issues/1347>)
  * Add timer coverage tests (#1363 <https://github.com/ros2/rclcpp/issues/1363>)
  * Add in additional tests for parameter_client.cpp coverage.
  * Minor fixes to the parameter_service.cpp file.
  * reset rcl_context shared_ptr after calling rcl_init sucessfully (#1357 <https://github.com/ros2/rclcpp/issues/1357>)
  * Improved test publisher - zero qos history depth value exception (#1360 <https://github.com/ros2/rclcpp/issues/1360>)
  * Covered resolve_use_intra_process (#1359 <https://github.com/ros2/rclcpp/issues/1359>)
  * Improve test_subscription_options (#1358 <https://github.com/ros2/rclcpp/issues/1358>)
  * Add in more tests for init_options coverage. (#1353 <https://github.com/ros2/rclcpp/issues/1353>)
  * Test the remaining node public API (#1342 <https://github.com/ros2/rclcpp/issues/1342>)
  * Complete coverage of Parameter and ParameterValue API (#1344 <https://github.com/ros2/rclcpp/issues/1344>)
  * Add in more tests for the utilities. (#1349 <https://github.com/ros2/rclcpp/issues/1349>)
  * Add in two more tests for expand_topic_or_service_name. (#1350 <https://github.com/ros2/rclcpp/issues/1350>)
  * Add tests for node_options API (#1343 <https://github.com/ros2/rclcpp/issues/1343>)
  * Add in more coverage for expand_topic_or_service_name. (#1346 <https://github.com/ros2/rclcpp/issues/1346>)
  * Test exception in spin_until_future_complete. (#1345 <https://github.com/ros2/rclcpp/issues/1345>)
  * Add coverage tests graph_listener (#1330 <https://github.com/ros2/rclcpp/issues/1330>)
  * Add in unit tests for the Executor class.
  * Allow mimick patching of methods with up to 9 arguments.
  * Improve the error messages in the Executor class.
  * Add coverage for client API (#1329 <https://github.com/ros2/rclcpp/issues/1329>)
  * Increase service coverage (#1332 <https://github.com/ros2/rclcpp/issues/1332>)
  * Make more of the static entity collector API private.
  * Const-ify more of the static executor.
  * Add more tests for the static single threaded executor.
  * Many more tests for the static_executor_entities_collector.
  * Get one more line of code coverage in memory_strategy.cpp
  * Bugfix when adding callback group.
  * Fix typos in comments.
  * Remove deprecated executor::FutureReturnCode APIs. (#1327 <https://github.com/ros2/rclcpp/issues/1327>)
  * Increase coverage of publisher/subscription API (#1325 <https://github.com/ros2/rclcpp/issues/1325>)
  * Not finalize guard condition while destructing SubscriptionIntraProcess (#1307 <https://github.com/ros2/rclcpp/issues/1307>)
  * Expose qos setting for /rosout (#1247 <https://github.com/ros2/rclcpp/issues/1247>)
  * Add coverage for missing API (except executors) (#1326 <https://github.com/ros2/rclcpp/issues/1326>)
  * Include topic name in QoS mismatch warning messages (#1286 <https://github.com/ros2/rclcpp/issues/1286>)
  * Add coverage tests context functions (#1321 <https://github.com/ros2/rclcpp/issues/1321>)
  * Increase coverage of node_interfaces, including with mocking rcl errors (#1322 <https://github.com/ros2/rclcpp/issues/1322>)
  * Contributors: Ada-King, Alejandro Hernández Cordero, Audrow Nash, Barry Xu, Chen Lihui, Chris Lalancette, Christophe Bedard, Ivan Santiago Paunovic, Jorge Perez, Morgan Quigley, brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 02 Nov 2020 06:00:00 -0000

ros-kilted-rclcpp (5.0.0-1noble) noble; urgency=high

  * Make node_graph::count_graph_users() const (#1320 <https://github.com/ros2/rclcpp/issues/1320>)
  * Add coverage for wait_set_policies (#1316 <https://github.com/ros2/rclcpp/issues/1316>)
  * Only exchange intra_process waitable if nonnull (#1317 <https://github.com/ros2/rclcpp/issues/1317>)
  * Check waitable for nullptr during constructor (#1315 <https://github.com/ros2/rclcpp/issues/1315>)
  * Call vector.erase with end iterator overload (#1314 <https://github.com/ros2/rclcpp/issues/1314>)
  * Use best effort, keep last, history depth 1 QoS Profile for '/clock' subscriptions (#1312 <https://github.com/ros2/rclcpp/issues/1312>)
  * Add tests type_support module (#1308 <https://github.com/ros2/rclcpp/issues/1308>)
  * Replace std_msgs with test_msgs in executors test (#1310 <https://github.com/ros2/rclcpp/issues/1310>)
  * Add set_level for rclcpp::Logger (#1284 <https://github.com/ros2/rclcpp/issues/1284>)
  * Remove unused private function (rclcpp::Node and rclcpp_lifecycle::Node) (#1294 <https://github.com/ros2/rclcpp/issues/1294>)
  * Adding tests basic getters (#1291 <https://github.com/ros2/rclcpp/issues/1291>)
  * Adding callback groups in executor (#1218 <https://github.com/ros2/rclcpp/issues/1218>)
  * Refactor Subscription Topic Statistics Tests (#1281 <https://github.com/ros2/rclcpp/issues/1281>)
  * Add operator!= for duration (#1236 <https://github.com/ros2/rclcpp/issues/1236>)
  * Fix clock thread issue (#1266 <https://github.com/ros2/rclcpp/issues/1266>) (#1267 <https://github.com/ros2/rclcpp/issues/1267>)
  * Fix topic stats test, wait for more messages, only check the ones with samples (#1274 <https://github.com/ros2/rclcpp/issues/1274>)
  * Add get_domain_id method to rclcpp::Context (#1271 <https://github.com/ros2/rclcpp/issues/1271>)
  * Fixes for unit tests that fail under cyclonedds (#1270 <https://github.com/ros2/rclcpp/issues/1270>)
  * initialize_logging_ should be copied (#1272 <https://github.com/ros2/rclcpp/issues/1272>)
  * Use static_cast instead of C-style cast for instrumentation (#1263 <https://github.com/ros2/rclcpp/issues/1263>)
  * Make parameter clients use template constructors (#1249 <https://github.com/ros2/rclcpp/issues/1249>)
  * Ability to configure domain_id via InitOptions. (#1165 <https://github.com/ros2/rclcpp/issues/1165>)
  * Simplify and fix allocator memory strategy unit test for connext (#1252 <https://github.com/ros2/rclcpp/issues/1252>)
  * Use global namespace for parameter events subscription topic (#1257 <https://github.com/ros2/rclcpp/issues/1257>)
  * Increase timeouts for connext for long tests (#1253 <https://github.com/ros2/rclcpp/issues/1253>)
  * Adjust test_static_executor_entities_collector for rmw_connext_cpp (#1251 <https://github.com/ros2/rclcpp/issues/1251>)
  * Fix failing test with Connext since it doesn't wait for discovery (#1246 <https://github.com/ros2/rclcpp/issues/1246>)
  * Fix node graph test with Connext and CycloneDDS returning actual data (#1245 <https://github.com/ros2/rclcpp/issues/1245>)
  * Warn about unused result of add_on_set_parameters_callback (#1238 <https://github.com/ros2/rclcpp/issues/1238>)
  * Unittests for memory strategy files, except allocator_memory_strategy (#1189 <https://github.com/ros2/rclcpp/issues/1189>)
  * EXPECT_THROW_EQ and ASSERT_THROW_EQ macros for unittests (#1232 <https://github.com/ros2/rclcpp/issues/1232>)
  * Add unit test for static_executor_entities_collector (#1221 <https://github.com/ros2/rclcpp/issues/1221>)
  * Parameterize test executors for all executor types (#1222 <https://github.com/ros2/rclcpp/issues/1222>)
  * Unit tests for allocator_memory_strategy.cpp part 2 (#1198 <https://github.com/ros2/rclcpp/issues/1198>)
  * Unit tests for allocator_memory_strategy.hpp (#1197 <https://github.com/ros2/rclcpp/issues/1197>)
  * Derive and throw exception in spin_some spin_all for StaticSingleThreadedExecutor (#1220 <https://github.com/ros2/rclcpp/issues/1220>)
  * Make ring buffer thread-safe (#1213 <https://github.com/ros2/rclcpp/issues/1213>)
  * Add missing RCLCPP_PUBLIC to ~StaticExecutorEntitiesCollector (#1227 <https://github.com/ros2/rclcpp/issues/1227>)
  * Document graph functions don't apply remap rules (#1225 <https://github.com/ros2/rclcpp/issues/1225>)
  * Remove recreation of entities_collector (#1217 <https://github.com/ros2/rclcpp/issues/1217>)
  * Contributors: Audrow Nash, Chen Lihui, Christophe Bedard, Daisuke Sato, Devin Bonnie, Dirk Thomas, Ivan Santiago Paunovic, Jacob Perron, Jannik Abbenseth, Jorge Perez, Pedro Pena, Shane Loretz, Stephen Brawner, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 18 Sep 2020 05:00:00 -0000

ros-kilted-rclcpp (4.0.0-1noble) noble; urgency=high

  * Fix rclcpp::NodeOptions::operator= (#1211 <https://github.com/ros2/rclcpp/issues/1211>)
  * Link against thread library where necessary (#1210 <https://github.com/ros2/rclcpp/issues/1210>)
  * Unit tests for node interfaces (#1202 <https://github.com/ros2/rclcpp/issues/1202>)
  * Remove usage of domain id in node options (#1205 <https://github.com/ros2/rclcpp/issues/1205>)
  * Remove deprecated set_on_parameters_set_callback function (#1199 <https://github.com/ros2/rclcpp/issues/1199>)
  * Fix conversion of negative durations to messages (#1188 <https://github.com/ros2/rclcpp/issues/1188>)
  * Fix implementation of NodeOptions::use_global_arguments() (#1176 <https://github.com/ros2/rclcpp/issues/1176>)
  * Bump to QD to level 3 and fixed links (#1158 <https://github.com/ros2/rclcpp/issues/1158>)
  * Fix pub/sub count API tests (#1203 <https://github.com/ros2/rclcpp/issues/1203>)
  * Update tracetools' QL to 2 in rclcpp's QD (#1187 <https://github.com/ros2/rclcpp/issues/1187>)
  * Fix exception message on rcl_clock_init (#1182 <https://github.com/ros2/rclcpp/issues/1182>)
  * Throw exception if rcl_timer_init fails (#1179 <https://github.com/ros2/rclcpp/issues/1179>)
  * Unit tests for some header-only functions/classes (#1181 <https://github.com/ros2/rclcpp/issues/1181>)
  * Callback should be perfectly-forwarded (#1183 <https://github.com/ros2/rclcpp/issues/1183>)
  * Add unit tests for logging functionality (#1184 <https://github.com/ros2/rclcpp/issues/1184>)
  * Add create_publisher include to create_subscription (#1180 <https://github.com/ros2/rclcpp/issues/1180>)
  * Contributors: Alejandro Hernández Cordero, Christophe Bedard, Claire Wang, Dirk Thomas, Ivan Santiago Paunovic, Johannes Meyer, Michel Hidalgo, Stephen Brawner, tomoya

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 09 Jul 2020 05:00:00 -0000

ros-kilted-rclcpp (3.0.0-1noble) noble; urgency=high

  * Check period duration in create_wall_timer (#1178 <https://github.com/ros2/rclcpp/issues/1178>)
  * Fix get_node_time_source_interface() docstring (#988 <https://github.com/ros2/rclcpp/issues/988>)
  * Add message lost subscription event (#1164 <https://github.com/ros2/rclcpp/issues/1164>)
  * Add spin_all method to Executor (#1156 <https://github.com/ros2/rclcpp/issues/1156>)
  * Reorganize test directory and split CMakeLists.txt (#1173 <https://github.com/ros2/rclcpp/issues/1173>)
  * Check if context is valid when looping in spin_some (#1167 <https://github.com/ros2/rclcpp/issues/1167>)
  * Add check for invalid topic statistics publish period (#1151 <https://github.com/ros2/rclcpp/issues/1151>)
  * Fix spin_until_future_complete: check spinning value (#1023 <https://github.com/ros2/rclcpp/issues/1023>)
  * Fix doxygen warnings (#1163 <https://github.com/ros2/rclcpp/issues/1163>)
  * Fix reference to rclcpp in its Quality declaration (#1161 <https://github.com/ros2/rclcpp/issues/1161>)
  * Allow spin_until_future_complete to accept any future like object (#1113 <https://github.com/ros2/rclcpp/issues/1113>)
  * Contributors: Alejandro Hernández Cordero, Christophe Bedard, Devin Bonnie, Dirk Thomas, DongheeYe, Ivan Santiago Paunovic, Jacob Perron, Sarthak Mittal, brawner, tomoya

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 18 Jun 2020 05:00:00 -0000

ros-kilted-rclcpp (2.0.0-1noble) noble; urgency=high

  * Added missing virtual destructors. (#1149 <https://github.com/ros2/rclcpp/issues/1149>)
  * Fixed a test which was using different types on the same topic. (#1150 <https://github.com/ros2/rclcpp/issues/1150>)
  * Made ``test_rate`` more reliable on Windows and improve error output when it fails (#1146 <https://github.com/ros2/rclcpp/issues/1146>)
  * Added Security Vulnerability Policy pointing to REP-2006. (#1130 <https://github.com/ros2/rclcpp/issues/1130>)
  * Added missing header in ``logging_mutex.cpp``. (#1145 <https://github.com/ros2/rclcpp/issues/1145>)
  * Changed the WaitSet API to pass a shared pointer by value instead than by const reference when possible. (#1141 <https://github.com/ros2/rclcpp/issues/1141>)
  * Changed ``SubscriptionBase::get_subscription_handle() const`` to return a shared pointer to const value. (#1140 <https://github.com/ros2/rclcpp/issues/1140>)
  * Extended the lifetime of ``rcl_publisher_t`` by holding onto the shared pointer in order to avoid a use after free situation. (#1119 <https://github.com/ros2/rclcpp/issues/1119>)
  * Improved some docblocks (#1127 <https://github.com/ros2/rclcpp/issues/1127>)
  * Fixed a lock-order-inversion (potential deadlock) (#1135 <https://github.com/ros2/rclcpp/issues/1135>)
  * Fixed a potential Construction/Destruction order problem between global contexts vector and Context of static lifetime (#1132 <https://github.com/ros2/rclcpp/issues/1132>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Ivan Santiago Paunovic, Michel Hidalgo, tomoya

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 01 Jun 2020 05:00:00 -0000

ros-kilted-rclcpp (1.1.0-1noble) noble; urgency=high

  * Deprecate set_on_parameters_set_callback (#1123 <https://github.com/ros2/rclcpp/issues/1123>)
  * Expose get_service_names_and_types_by_node from rcl in rclcpp (#1131 <https://github.com/ros2/rclcpp/issues/1131>)
  * Fix thread safety issues related to logging (#1125 <https://github.com/ros2/rclcpp/issues/1125>)
  * Make sure rmw_publisher_options is initialized in to_rcl_publisher_options (#1099 <https://github.com/ros2/rclcpp/issues/1099>)
  * Remove empty lines within method signatures (#1128 <https://github.com/ros2/rclcpp/issues/1128>)
  * Add API review March 2020 document (#1031 <https://github.com/ros2/rclcpp/issues/1031>)
  * Improve documentation (#1106 <https://github.com/ros2/rclcpp/issues/1106>)
  * Make test multi threaded executor more reliable (#1105 <https://github.com/ros2/rclcpp/issues/1105>)
  * Fixed rep links and added more details to dependencies in quality declaration (#1116 <https://github.com/ros2/rclcpp/issues/1116>)
  * Update quality declarations to reflect version 1.0 (#1115 <https://github.com/ros2/rclcpp/issues/1115>)
  * Contributors: Alejandro Hernández Cordero, ChenYing Kuo, Claire Wang, Dirk Thomas, Ivan Santiago Paunovic, William Woodall, Stephen Brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 26 May 2020 05:00:00 -0000

ros-kilted-rclcpp (1.0.0-1noble) noble; urgency=high

  * Remove MANUAL_BY_NODE liveliness API (#1107 <https://github.com/ros2/rclcpp/issues/1107>)
  * Use rosidl_default_generators dependency in test (#1114 <https://github.com/ros2/rclcpp/issues/1114>)
  * Make sure to include what you use (#1112 <https://github.com/ros2/rclcpp/issues/1112>)
  * Mark flaky test with xfail: TestMultiThreadedExecutor (#1109 <https://github.com/ros2/rclcpp/issues/1109>)
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic, Karsten Knese, Louise Poubel

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 12 May 2020 05:00:00 -0000

ros-kilted-rclcpp (0.9.1-1noble) noble; urgency=high

  * Fix tests that were not properly torn down (#1073 <https://github.com/ros2/rclcpp/issues/1073>)
  * Added docblock in rclcpp (#1103 <https://github.com/ros2/rclcpp/issues/1103>)
  * Added Quality declaration: rclcpp, rclpp_action, rclcpp_components andrclcpp_lifecycle (#1100 <https://github.com/ros2/rclcpp/issues/1100>)
  * Use RCL_RET_SERVICE_TAKE_FAILED and not RCL_RET_CLIENT_TAKE_FAILED when checking a request take (#1101 <https://github.com/ros2/rclcpp/issues/1101>)
  * Update comment about return value in Executor::get_next_ready_executable (#1085 <https://github.com/ros2/rclcpp/issues/1085>)
  * Contributors: Alejandro Hernández Cordero, Christophe Bedard, Devin Bonnie, Ivan Santiago Paunovic

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 08 May 2020 05:00:00 -0000

ros-kilted-rclcpp (0.9.0-1noble) noble; urgency=high

  * Serialized message move constructor (#1097 <https://github.com/ros2/rclcpp/issues/1097>)
  * Enforce a precedence for wildcard matching in parameter overrides. (#1094 <https://github.com/ros2/rclcpp/issues/1094>)
  * Add serialized_message.hpp header (#1095 <https://github.com/ros2/rclcpp/issues/1095>)
  * Add received message age metric to topic statistics (#1080 <https://github.com/ros2/rclcpp/issues/1080>)
  * Deprecate redundant namespaces (#1083 <https://github.com/ros2/rclcpp/issues/1083>)
  * Export targets in addition to include directories / libraries (#1088 <https://github.com/ros2/rclcpp/issues/1088>)
  * Ensure logging is initialized just once (#998 <https://github.com/ros2/rclcpp/issues/998>)
  * Adapt subscription traits to rclcpp::SerializedMessage (#1092 <https://github.com/ros2/rclcpp/issues/1092>)
  * Protect subscriber_statistics_collectors_ with a mutex (#1084 <https://github.com/ros2/rclcpp/issues/1084>)
  * Remove unused test variable (#1087 <https://github.com/ros2/rclcpp/issues/1087>)
  * Use serialized message (#1081 <https://github.com/ros2/rclcpp/issues/1081>)
  * Integrate topic statistics (#1072 <https://github.com/ros2/rclcpp/issues/1072>)
  * Fix rclcpp interface traits test (#1086 <https://github.com/ros2/rclcpp/issues/1086>)
  * Generate node interfaces' getters and traits (#1069 <https://github.com/ros2/rclcpp/issues/1069>)
  * Use composition for serialized message (#1082 <https://github.com/ros2/rclcpp/issues/1082>)
  * Dnae adas/serialized message (#1075 <https://github.com/ros2/rclcpp/issues/1075>)
  * Reflect changes in rclcpp API (#1079 <https://github.com/ros2/rclcpp/issues/1079>)
  * Fix build regression (#1078 <https://github.com/ros2/rclcpp/issues/1078>)
  * Add NodeDefault option for enabling topic statistics (#1074 <https://github.com/ros2/rclcpp/issues/1074>)
  * Topic Statistics: Add SubscriptionTopicStatistics class (#1050 <https://github.com/ros2/rclcpp/issues/1050>)
  * Add SubscriptionOptions for topic statistics (#1057 <https://github.com/ros2/rclcpp/issues/1057>)
  * Remove warning message from failing to register default callback (#1067 <https://github.com/ros2/rclcpp/issues/1067>)
  * Create a default warning for qos incompatibility (#1051 <https://github.com/ros2/rclcpp/issues/1051>)
  * Add WaitSet class and modify entities to work without executor (#1047 <https://github.com/ros2/rclcpp/issues/1047>)
  * Include what you use (#1059 <https://github.com/ros2/rclcpp/issues/1059>)
  * Rename rosidl_generator_cpp namespace to rosidl_runtime_cpp (#1060 <https://github.com/ros2/rclcpp/issues/1060>)
  * Changed rosidl_generator_c/cpp to rosidl_runtime_c/cpp (#1014 <https://github.com/ros2/rclcpp/issues/1014>)
  * Use constexpr for endpoint type name (#1055 <https://github.com/ros2/rclcpp/issues/1055>)
  * Add InvalidParameterTypeException (#1027 <https://github.com/ros2/rclcpp/issues/1027>)
  * Support for ON_REQUESTED_INCOMPATIBLE_QOS and ON_OFFERED_INCOMPATIBLE_QOS events (#924 <https://github.com/ros2/rclcpp/issues/924>)
  * Fixup clang warning (#1040 <https://github.com/ros2/rclcpp/issues/1040>)
  * Adding a "static" single threaded executor (#1034 <https://github.com/ros2/rclcpp/issues/1034>)
  * Add equality operators for QoS profile (#1032 <https://github.com/ros2/rclcpp/issues/1032>)
  * Remove extra vertical whitespace (#1030 <https://github.com/ros2/rclcpp/issues/1030>)
  * Switch IntraProcessMessage to test_msgs/Empty (#1017 <https://github.com/ros2/rclcpp/issues/1017>)
  * Add new type of exception that may be thrown during creation of publisher/subscription (#1026 <https://github.com/ros2/rclcpp/issues/1026>)
  * Don't check lifespan on publisher QoS (#1002 <https://github.com/ros2/rclcpp/issues/1002>)
  * Fix get_parameter_tyeps of AsyncPrameterClient results are always empty (#1019 <https://github.com/ros2/rclcpp/issues/1019>)
  * Cleanup node interfaces includes (#1016 <https://github.com/ros2/rclcpp/issues/1016>)
  * Add ifdefs to remove tracing-related calls if tracing is disabled (#1001 <https://github.com/ros2/rclcpp/issues/1001>)
  * Include missing header in node_graph.cpp (#994 <https://github.com/ros2/rclcpp/issues/994>)
  * Add missing includes of logging.hpp (#995 <https://github.com/ros2/rclcpp/issues/995>)
  * Zero initialize publisher GID in subscription intra process callback (#1011 <https://github.com/ros2/rclcpp/issues/1011>)
  * Removed ament_cmake dependency (#989 <https://github.com/ros2/rclcpp/issues/989>)
  * Switch to using new rcutils_strerror (#993 <https://github.com/ros2/rclcpp/issues/993>)
  * Ensure all rclcpp::Clock accesses are thread-safe
  * Use a PIMPL for rclcpp::Clock implementation
  * Replace rmw_implementation for rmw dependency in package.xml (#990 <https://github.com/ros2/rclcpp/issues/990>)
  * Add missing service callback registration tracepoint (#986 <https://github.com/ros2/rclcpp/issues/986>)
  * Rename rmw_topic_endpoint_info_array count to size (#996 <https://github.com/ros2/rclcpp/issues/996>)
  * Implement functions to get publisher and subcription informations like QoS policies from topic name (#960 <https://github.com/ros2/rclcpp/issues/960>)
  * Code style only: wrap after open parenthesis if not in one line (#977 <https://github.com/ros2/rclcpp/issues/977>)
  * Accept taking an rvalue ref future in spin_until_future_complete (#971 <https://github.com/ros2/rclcpp/issues/971>)
  * Allow node clock use in logging macros (#969 <https://github.com/ros2/rclcpp/issues/969>) (#970 <https://github.com/ros2/rclcpp/issues/970>)
  * Change order of deprecated and visibility attributes (#968 <https://github.com/ros2/rclcpp/issues/968>)
  * Deprecated is_initialized() (#967 <https://github.com/ros2/rclcpp/issues/967>)
  * Don't specify calling convention in std::_Binder template (#952 <https://github.com/ros2/rclcpp/issues/952>)
  * Added missing include to logging.hpp (#964 <https://github.com/ros2/rclcpp/issues/964>)
  * Assigning make_shared result to variables in test (#963 <https://github.com/ros2/rclcpp/issues/963>)
  * Fix unused parameter warning (#962 <https://github.com/ros2/rclcpp/issues/962>)
  * Stop retaining ownership of the rcl context in GraphListener (#946 <https://github.com/ros2/rclcpp/issues/946>)
  * Clear sub contexts when starting another init-shutdown cycle (#947 <https://github.com/ros2/rclcpp/issues/947>)
  * Avoid possible UB in Clock jump callbacks (#954 <https://github.com/ros2/rclcpp/issues/954>)
  * Handle unknown global ROS arguments (#951 <https://github.com/ros2/rclcpp/issues/951>)
  * Mark get_clock() as override to fix clang warnings (#939 <https://github.com/ros2/rclcpp/issues/939>)
  * Create node clock calls const (try 2) (#922 <https://github.com/ros2/rclcpp/issues/922>)
  * Fix asserts on shared_ptr::use_count; expects long, got uint32 (#936 <https://github.com/ros2/rclcpp/issues/936>)
  * Use absolute topic name for parameter events (#929 <https://github.com/ros2/rclcpp/issues/929>)
  * Add enable_rosout into NodeOptions. (#900 <https://github.com/ros2/rclcpp/issues/900>)
  * Removing "virtual", adding "override" keywords (#897 <https://github.com/ros2/rclcpp/issues/897>)
  * Use weak_ptr to store context in GraphListener (#906 <https://github.com/ros2/rclcpp/issues/906>)
  * Complete published event message when declaring a parameter (#928 <https://github.com/ros2/rclcpp/issues/928>)
  * Fix duration.cpp lint error (#930 <https://github.com/ros2/rclcpp/issues/930>)
  * Intra-process subscriber should use RMW actual qos. (ros2`#913 <https://github.com/ros2/rclcpp/issues/913>`_) (#914 <https://github.com/ros2/rclcpp/issues/914>)
  * Type conversions fixes (#901 <https://github.com/ros2/rclcpp/issues/901>)
  * Add override keyword to functions
  * Remove unnecessary virtual keywords
  * Only check for new work once in spin_some (#471 <https://github.com/ros2/rclcpp/issues/471>) (#844 <https://github.com/ros2/rclcpp/issues/844>)
  * Add addition/subtraction assignment operators to Time (#748 <https://github.com/ros2/rclcpp/issues/748>)
  * Contributors: Alberto Soragna, Alejandro Hernández Cordero, Barry Xu, Chris Lalancette, Christophe Bedard, Claire Wang, Dan Rose, DensoADAS, Devin Bonnie, Dino Hüllmann, Dirk Thomas, DongheeYe, Emerson Knapp, Ivan Santiago Paunovic, Jacob Perron, Jaison Titus, Karsten Knese, Matt Schickler, Miaofei Mei, Michel Hidalgo, Mikael Arguedas, Monika Idzik, Prajakta Gokhale, Roger Strain, Scott K Logan, Sean Kelly, Stephen Brawner, Steven Macenski, Steven! Ragnarök, Todd Malsbary, Tomoya Fujita, William Woodall, Zachary Michaels

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 29 Apr 2020 05:00:00 -0000

ros-kilted-rclcpp (0.8.3-1noble) noble; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 19 Nov 2019 06:00:00 -0000

ros-kilted-rclcpp (0.8.2-1noble) noble; urgency=high

  * Updated tracing logic to match changes in rclcpp's intra-process system (#918 <https://github.com/ros2/rclcpp/issues/918>)
  * Fixed a bug that prevented the ``shutdown_on_sigint`` option to not work correctly (#850 <https://github.com/ros2/rclcpp/issues/850>)
  * Added support for STREAM logging macros (#926 <https://github.com/ros2/rclcpp/issues/926>)
  * Relaxed multithreaded test constraint (#907 <https://github.com/ros2/rclcpp/issues/907>)
  * Contributors: Anas Abou Allaban, Christophe Bedard, Dirk Thomas, alexfneves

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 18 Nov 2019 06:00:00 -0000

ros-kilted-rclcpp (0.8.1-1noble) noble; urgency=high

  * De-flake tests for rmw_connext (#899 <https://github.com/ros2/rclcpp/issues/899>)
  * rename return functions for loaned messages (#896 <https://github.com/ros2/rclcpp/issues/896>)
  * Enable throttling logs (#879 <https://github.com/ros2/rclcpp/issues/879>)
  * New Intra-Process Communication (#778 <https://github.com/ros2/rclcpp/issues/778>)
  * Instrumentation update (#789 <https://github.com/ros2/rclcpp/issues/789>)
  * Zero copy api (#864 <https://github.com/ros2/rclcpp/issues/864>)
  * Drop rclcpp remove_ros_arguments_null test case. (#894 <https://github.com/ros2/rclcpp/issues/894>)
  * add mechanism to pass rmw impl specific payloads during pub/sub creation (#882 <https://github.com/ros2/rclcpp/issues/882>)
  * make get_actual_qos return a rclcpp::QoS (#883 <https://github.com/ros2/rclcpp/issues/883>)
  * Fix Compiler Warning (#881 <https://github.com/ros2/rclcpp/issues/881>)
  * Add callback handler for use_sim_time parameter #802 <https://github.com/ros2/rclcpp/issues/802> (#875 <https://github.com/ros2/rclcpp/issues/875>)
  * Contributors: Alberto Soragna, Brian Marchi, Hunter L. Allen, Ingo Lütkebohle, Karsten Knese, Michael Carroll, Michel Hidalgo, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 23 Oct 2019 05:00:00 -0000

ros-kilted-rclcpp (0.8.0-1noble) noble; urgency=high

  * clean up publisher and subscription creation logic (#867 <https://github.com/ros2/rclcpp/issues/867>)
  * Take parameter overrides provided through the CLI. (#865 <https://github.com/ros2/rclcpp/issues/865>)
  * add more context to exception message (#858 <https://github.com/ros2/rclcpp/issues/858>)
  * remove features and related code which were deprecated in dashing (#852 <https://github.com/ros2/rclcpp/issues/852>)
  * check valid timer handler 1st to reduce the time window for scan. (#841 <https://github.com/ros2/rclcpp/issues/841>)
  * Add throwing parameter name if parameter is not set (#833 <https://github.com/ros2/rclcpp/issues/833>)
  * Fix typo in deprecated warning. (#848 <https://github.com/ros2/rclcpp/issues/848>)
  * Fail on invalid and unknown ROS specific arguments (#842 <https://github.com/ros2/rclcpp/issues/842>)
  * Force explicit --ros-args in NodeOptions::arguments(). (#845 <https://github.com/ros2/rclcpp/issues/845>)
  * Use of -r/--remap flags where appropriate. (#834 <https://github.com/ros2/rclcpp/issues/834>)
  * Fix hang with timers in MultiThreadedExecutor (#835 <https://github.com/ros2/rclcpp/issues/835>) (#836 <https://github.com/ros2/rclcpp/issues/836>)
  * add mutex in add/remove_node and wait_for_work to protect concurrent use/change of memory_strategy_ (#837 <https://github.com/ros2/rclcpp/issues/837>)
  * Crash in callback group pointer vector iterator (#814 <https://github.com/ros2/rclcpp/issues/814>)
  * Wrap documentation examples in code blocks (#830 <https://github.com/ros2/rclcpp/issues/830>)
  * add callback group as member variable and constructor arg (#811 <https://github.com/ros2/rclcpp/issues/811>)
  * Fix get_node_interfaces functions taking a pointer (#821 <https://github.com/ros2/rclcpp/issues/821>)
  * Delete unnecessary call for get_node_by_group (#823 <https://github.com/ros2/rclcpp/issues/823>)
  * Allow passing logger by const ref (#820 <https://github.com/ros2/rclcpp/issues/820>)
  * Explain return value of spin_until_future_complete (#792 <https://github.com/ros2/rclcpp/issues/792>)
  * Adapt to '--ros-args ... [--]'-based ROS args extraction (#816 <https://github.com/ros2/rclcpp/issues/816>)
  * Add line break after first open paren in multiline function call (#785 <https://github.com/ros2/rclcpp/issues/785>)
  * remove mock msgs from rclcpp (#800 <https://github.com/ros2/rclcpp/issues/800>)
  * Make TimeSource ignore use_sim_time events coming from other nodes. (#799 <https://github.com/ros2/rclcpp/issues/799>)
  * Allow registering multiple on_parameters_set_callback (#772 <https://github.com/ros2/rclcpp/issues/772>)
  * Add free function for creating service clients (#788 <https://github.com/ros2/rclcpp/issues/788>)
  * Include missing rcl headers in use. (#782 <https://github.com/ros2/rclcpp/issues/782>)
  * Switch the NodeParameters lock to recursive. (#781 <https://github.com/ros2/rclcpp/issues/781>)
  * changed on_parameter_event qos profile to rmw_qos_profile_parameter_events (#774 <https://github.com/ros2/rclcpp/issues/774>)
  * Adding a factory method to create a Duration from seconds (#567 <https://github.com/ros2/rclcpp/issues/567>)
  * Fix a comparison with a sign mismatch (#771 <https://github.com/ros2/rclcpp/issues/771>)
  * delete superfluous spaces (#770 <https://github.com/ros2/rclcpp/issues/770>)
  * Use params from node '/**' from parameter YAML file (#762 <https://github.com/ros2/rclcpp/issues/762>)
  * Add ignore override argument to declare parameter (#767 <https://github.com/ros2/rclcpp/issues/767>)
  * use default parameter descriptor in parameters interface (#765 <https://github.com/ros2/rclcpp/issues/765>)
  * Added support for const member functions (#763 <https://github.com/ros2/rclcpp/issues/763>)
  * add get_actual_qos() feature to subscriptions (#754 <https://github.com/ros2/rclcpp/issues/754>)
  * Ignore parameters overrides in set parameter methods when allowing undeclared parameters (#756 <https://github.com/ros2/rclcpp/issues/756>)
  * Add rclcpp::create_timer() (#757 <https://github.com/ros2/rclcpp/issues/757>)
  * checking origin of intra-process msg before taking them (#753 <https://github.com/ros2/rclcpp/issues/753>)
  * Contributors: Alberto Soragna, Carl Delsey, Chris Lalancette, Dan Rose, Dirk Thomas, Esteve Fernandez, Guillaume Autran, Jacob Perron, Karsten Knese, Luca Della Vedova, M. M, Michel Hidalgo, Scott K Logan, Shane Loretz, Todd Malsbary, William Woodall, bpwilcox, fujitatomoya, ivanpauno

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 26 Sep 2019 05:00:00 -0000

ros-kilted-rclcpp (0.7.5-1noble) noble; urgency=high

  * Avoid 'Intra process message no longer being stored when trying to handle it' warning (#749 <https://github.com/ros2/rclcpp/issues/749>)
  * Contributors: ivanpauno

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 30 May 2019 05:00:00 -0000

ros-kilted-rclcpp (0.7.4-1noble) noble; urgency=high

  * Rename parameter options (#745 <https://github.com/ros2/rclcpp/issues/745>)
  * Bionic use of strerror_r (#742 <https://github.com/ros2/rclcpp/issues/742>)
  * Enforce parameter ranges (#735 <https://github.com/ros2/rclcpp/issues/735>)
  * removed not used parameter client (#740 <https://github.com/ros2/rclcpp/issues/740>)
  * ensure removal of guard conditions of expired nodes from memory strategy (#741 <https://github.com/ros2/rclcpp/issues/741>)
  * Fix typo in log warning message (#737 <https://github.com/ros2/rclcpp/issues/737>)
  * Throw nice errors when creating a publisher with intraprocess communication and incompatible qos policy (#729 <https://github.com/ros2/rclcpp/issues/729>)
  * Contributors: Alberto Soragna, Dirk Thomas, Jacob Perron, William Woodall, ivanpauno, roderick-koehle

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 29 May 2019 05:00:00 -0000

ros-kilted-rclcpp (0.7.3-1noble) noble; urgency=high

  * Fixed misspelling, volitile -> volatile (#724 <https://github.com/ros2/rclcpp/issues/724>), and then fixed that since it is a C++ keyword to be ``durability_volatile`` (#725 <https://github.com/ros2/rclcpp/issues/725>)
  * Fixed a clang warning (#723 <https://github.com/ros2/rclcpp/issues/723>)
  * Added ``on_parameter_event`` static method to the ``AsyncParametersClient`` (#688 <https://github.com/ros2/rclcpp/issues/688>)
  * Added a guard against ``ParameterNotDeclaredException`` throwing from within the parameter service callbacks. (#718 <https://github.com/ros2/rclcpp/issues/718>)
  * Added missing template functionality to lifecycle_node. (#707 <https://github.com/ros2/rclcpp/issues/707>)
  * Fixed heap-use-after-free and memory leaks reported from ``test_node.cpp`` (#719 <https://github.com/ros2/rclcpp/issues/719>)
  * Contributors: Alberto Soragna, Dirk Thomas, Emerson Knapp, Jacob Perron, Michael Jeronimo, Prajakta Gokhale

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 20 May 2019 05:00:00 -0000

ros-kilted-rclcpp (0.7.2-1noble) noble; urgency=high

  * Added new way to specify QoS settings for publishers and subscriptions. (#713 <https://github.com/ros2/rclcpp/issues/713>)
    * The new way requires that you specify a history depth when creating a publisher or subscription.
    * In the past it was possible to create one without specifying any history depth, but these signatures have been deprecated.
  * Deprecated ``shared_ptr`` and raw pointer versions of ``Publisher<T>::publish()``. (#709 <https://github.com/ros2/rclcpp/issues/709>)
  * Implemented API to set callbacks for liveliness and deadline QoS events for publishers and subscriptions. (#695 <https://github.com/ros2/rclcpp/issues/695>)
  * Fixed a segmentation fault when publishing a parameter event when they ought to be disabled. (#714 <https://github.com/ros2/rclcpp/issues/714>)
  * Changes required for upcoming pre-allocation API. (#711 <https://github.com/ros2/rclcpp/issues/711>)
  * Changed ``Node::get_node_names()`` to return the full node names rather than just the base name. (#698 <https://github.com/ros2/rclcpp/issues/698>)
  * Remove logic made redundant by the ros2/rcl#255 <https://github.com/ros2/rcl/issues/255> pull request. (#712 <https://github.com/ros2/rclcpp/issues/712>)
  * Various improvements for ``rclcpp::Clock``. (#696 <https://github.com/ros2/rclcpp/issues/696>)
    * Fixed uninitialized bool in ``clock.cpp``.
    * Fixed up includes of ``clock.hpp/cpp``.
    * Added documentation for exceptions to ``clock.hpp``.
    * Adjusted function signature of getters of ``clock.hpp/cpp``.
    * Removed raw pointers to ``Clock::create_jump_callback``.
    * Removed unnecessary ``rclcpp`` namespace reference from ``clock.cpp``.
    * Changed exception to ``bad_alloc`` on ``JumpHandler`` allocation failure.
    * Fixed missing ``nullptr`` check in ``Clock::on_time_jump``.
    * Added ``JumpHandler::callback`` types.
    * Added warning for lifetime of Clock and JumpHandler
  * Fixed bug left over from the pull request #495 <https://github.com/ros2/rclcpp/pull/495>. (#708 <https://github.com/ros2/rclcpp/issues/708>)
  * Changed the ``IntraProcessManager`` to be capable of storing ``shared_ptr<const T>`` in addition to ``unique_ptr<T>``. (#690 <https://github.com/ros2/rclcpp/issues/690>)
  * Contributors: Alberto Soragna, Dima Dorezyuk, M. M, Michael Carroll, Michael Jeronimo, Tully Foote, William Woodall, ivanpauno, jhdcs

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 08 May 2019 05:00:00 -0000

ros-kilted-rclcpp (0.7.1-1noble) noble; urgency=high

  * Added read only parameters. (#495 <https://github.com/ros2/rclcpp/issues/495>)
  * Fixed a concurrency problem in the multithreaded executor. (#703 <https://github.com/ros2/rclcpp/issues/703>)
  * Fixup utilities. (#692 <https://github.com/ros2/rclcpp/issues/692>)
  * Added method to read timer cancellation. (#697 <https://github.com/ros2/rclcpp/issues/697>)
  * Added Exception Generator function for implementing "from_rcl_error". (#678 <https://github.com/ros2/rclcpp/issues/678>)
  * Updated initialization of rmw_qos_profile_t struct instances. (#691 <https://github.com/ros2/rclcpp/issues/691>)
  * Removed the const value from the logger before comparison. (#680 <https://github.com/ros2/rclcpp/issues/680>)
  * Contributors: Devin Bonnie, Dima Dorezyuk, Guillaume Autran, M. M, Shane Loretz, Víctor Mayoral Vilches, William Woodall, jhdcs

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 26 Apr 2019 05:00:00 -0000

ros-kilted-rclcpp (0.7.0-1noble) noble; urgency=high

  * Added Options-struct interfaces for creating publishers/subscribers (pre-QoS, standalone). (#673 <https://github.com/ros2/rclcpp/issues/673>)
  * Replaced strncpy with memcpy. (#684 <https://github.com/ros2/rclcpp/issues/684>)
  * Replaced const char * with a std::array<char, TOPIC_NAME_LENGTH> as the key of IPM IDTopicMap. (#671 <https://github.com/ros2/rclcpp/issues/671>)
  * Refactored SignalHandler logger to avoid race during destruction. (#682 <https://github.com/ros2/rclcpp/issues/682>)
  * Introduce rclcpp_components to implement composition. (#665 <https://github.com/ros2/rclcpp/issues/665>)
  * Added QoS policy check when configuring intraprocess, skip interprocess publish when possible. (#674 <https://github.com/ros2/rclcpp/issues/674>)
  * Updated to use do { .. } while(0) around content of logging macros. (#681 <https://github.com/ros2/rclcpp/issues/681>)
  * Added function to get publisher's actual QoS settings. (#667 <https://github.com/ros2/rclcpp/issues/667>)
  * Updated to avoid race that triggers timer too often. (#621 <https://github.com/ros2/rclcpp/issues/621>)
  * Exposed get_fully_qualified_name in NodeBase API. (#662 <https://github.com/ros2/rclcpp/issues/662>)
  * Updated to use ament_target_dependencies where possible. (#659 <https://github.com/ros2/rclcpp/issues/659>)
  * Fixed wait for service memory leak bug. (#656 <https://github.com/ros2/rclcpp/issues/656>)
  * Fixed test_time_source test. (#639 <https://github.com/ros2/rclcpp/issues/639>)
  * Fixed hard-coded duration type representation so int64_t isn't assumed. (#648 <https://github.com/ros2/rclcpp/issues/648>)
  * Fixed cppcheck warning. (#646 <https://github.com/ros2/rclcpp/issues/646>)
  * Added count matching api and intra-process subscriber count. (#628 <https://github.com/ros2/rclcpp/issues/628>)
  * Added Sub Node alternative. (#581 <https://github.com/ros2/rclcpp/issues/581>)
  * Replaced 'auto' with 'const auto &'. (#630 <https://github.com/ros2/rclcpp/issues/630>)
  * Set Parameter Event Publisher settings. #591 <https://github.com/ros2/rclcpp/issues/591> (#614 <https://github.com/ros2/rclcpp/issues/614>)
  * Replaced node constructor arguments with NodeOptions. (#622 <https://github.com/ros2/rclcpp/issues/622>)
  * Updated to pass context to wait set (#617 <https://github.com/ros2/rclcpp/issues/617>)
  * Added API to get parameters in a map. (#575 <https://github.com/ros2/rclcpp/issues/575>)
  * Updated Bind usage since it is is no longer in std::__1. (#618 <https://github.com/ros2/rclcpp/issues/618>)
  * Fixed errors from uncrustify v0.68. (#613 <https://github.com/ros2/rclcpp/issues/613>)
  * Added new constructors for SyncParameterClient. (#612 <https://github.com/ros2/rclcpp/issues/612>)
  * Contributors: Alberto Soragna, Chris Lalancette, Dirk Thomas, Emerson Knapp, Francisco Martín Rico, Jacob Perron, Marko Durkovic, Michael Carroll, Peter Baughman, Shane Loretz, Wei Liu, William Woodall, Yutaka Kondo, ivanpauno, kuzai, rarvolt

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Sun, 14 Apr 2019 05:00:00 -0000

ros-kilted-rclcpp (0.6.2-1noble) noble; urgency=high

  * Updated to use signal safe synchronization with platform specific semaphores (#607 <https://github.com/ros2/rclcpp/issues/607>)
  * Resolved startup race condition for sim time (#608 <https://github.com/ros2/rclcpp/issues/608>)
    Resolves #595 <https://github.com/ros2/rclcpp/issues/595>
  * Contributors: Tully Foote, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 13 Dec 2018 06:00:00 -0000

ros-kilted-rclcpp (0.6.1-1noble) noble; urgency=high

  * Added wait_for_action_server() for action clients (#598 <https://github.com/ros2/rclcpp/issues/598>)
  * Added node path and time stamp to parameter event message (#584 <https://github.com/ros2/rclcpp/issues/584>)
  * Updated to allow removing a waitable (#597 <https://github.com/ros2/rclcpp/issues/597>)
  * Refactored init to allow for non-global init (#587 <https://github.com/ros2/rclcpp/issues/587>)
  * Fixed wrong use of constructor and hanging test (#596 <https://github.com/ros2/rclcpp/issues/596>)
  * Added class Waitable (#589 <https://github.com/ros2/rclcpp/issues/589>)
  * Updated rcl_wait_set_add_* calls (#586 <https://github.com/ros2/rclcpp/issues/586>)
  * Contributors: Dirk Thomas, Jacob Perron, Shane Loretz, William Woodall, bpwilcox

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 07 Dec 2018 06:00:00 -0000

ros-kilted-rclcpp (0.6.0-1noble) noble; urgency=high

  * Updated to use new error handling API from rcutils (#577 <https://github.com/ros2/rclcpp/issues/577>)
  * Added a warning when publishing if publisher is not active (#574 <https://github.com/ros2/rclcpp/issues/574>)
  * Added logging macro signature that accepts std::string (#573 <https://github.com/ros2/rclcpp/issues/573>)
  * Added virtual destructors to classes with virtual functions. (#566 <https://github.com/ros2/rclcpp/issues/566>)
  * Added semicolons to all RCLCPP and RCUTILS macros. (#565 <https://github.com/ros2/rclcpp/issues/565>)
  * Removed std::binary_function usage (#561 <https://github.com/ros2/rclcpp/issues/561>)
  * Updated to avoid auto-activating ROS time if clock topic is being published (#559 <https://github.com/ros2/rclcpp/issues/559>)
  * Fixed cpplint on xenial (#556 <https://github.com/ros2/rclcpp/issues/556>)
  * Added get_parameter_or_set_default. (#551 <https://github.com/ros2/rclcpp/issues/551>)
  * Added max_duration to spin_some() (#558 <https://github.com/ros2/rclcpp/issues/558>)
  * Updated to output rcl error message when yaml parsing fails (#557 <https://github.com/ros2/rclcpp/issues/557>)
  * Updated to make sure timer is fini'd before clock (#553 <https://github.com/ros2/rclcpp/issues/553>)
  * Get node names and namespaces (#545 <https://github.com/ros2/rclcpp/issues/545>)
  * Fixed and improved documentation  (#546 <https://github.com/ros2/rclcpp/issues/546>)
  * Updated to use rcl_clock_t jump callbacks (#543 <https://github.com/ros2/rclcpp/issues/543>)
  * Updated to use rcl consolidated wait set functions (#540 <https://github.com/ros2/rclcpp/issues/540>)
  * Addeed TIME_MAX and DURATION_MAX functions (#538 <https://github.com/ros2/rclcpp/issues/538>)
  * Updated to publish shared_ptr of rcl_serialized_message (#541 <https://github.com/ros2/rclcpp/issues/541>)
  * Added Time::is_zero and Duration::seconds (#536 <https://github.com/ros2/rclcpp/issues/536>)
  * Changed to log an error message instead of throwing exception in destructor (#535 <https://github.com/ros2/rclcpp/issues/535>)
  * Updated to relax tolerance of now test because timing affected by OS scheduling (#533 <https://github.com/ros2/rclcpp/issues/533>)
  * Removed incorrect exception on sec < 0 (#527 <https://github.com/ros2/rclcpp/issues/527>)
  * Added rclcpp::Time::seconds() (#526 <https://github.com/ros2/rclcpp/issues/526>)
  * Updated Timer API to construct TimerBase/GenericTimer with Clock (#523 <https://github.com/ros2/rclcpp/issues/523>)
  * Added rclcpp::is_initialized() (#522 <https://github.com/ros2/rclcpp/issues/522>)
  * Added support for jump handlers with only pre- or post-jump callback (#517 <https://github.com/ros2/rclcpp/issues/517>)
  * Removed use of uninitialized CMake var (#512 <https://github.com/ros2/rclcpp/issues/512>)
  * Updated for Uncrustify 0.67 (#510 <https://github.com/ros2/rclcpp/issues/510>)
  * Added get_node_names API from node. (#508 <https://github.com/ros2/rclcpp/issues/508>)
  * Contributors: Anis Ladram, Chris Lalancette, Dirk Thomas, Francisco Martín Rico, Karsten Knese, Michael Carroll, Mikael Arguedas, Sagnik Basu, Shane Loretz, Sriram Raghunathan, William Woodall, chapulina, dhood

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 19 Nov 2018 06:00:00 -0000

ros-kilted-rclcpp (0.5.0-1noble) noble; urgency=high

  * Fixed a bug in the multi-threaded executor which could cause it to take a timer (potentially other types of wait-able items) more than once to be worked one. (#383 <https://github.com/ros2/rclcpp/issues/383>)
    * Specifically this could result in a timer getting called more often that it should when using the multi-threaded executor.
  * Added functions that allow you to publish serialized messages and received serialized messages in your subscription callback. (#388 <https://github.com/ros2/rclcpp/issues/388>)
  * Changed code to always get the Service name from ``rcl`` to ensure the remapped name is returned. (#498 <https://github.com/ros2/rclcpp/issues/498>)
  * Added previously missing ``set_parameters_atomically()`` method to the Service client interface. (#494 <https://github.com/ros2/rclcpp/issues/494>)
  * Added ability to initialize parameter values in a Node via a YAML file passed on the command line. (#488 <https://github.com/ros2/rclcpp/issues/488>)
  * Fixed the ROS parameter interface which got parameters that aren't set. (#493 <https://github.com/ros2/rclcpp/issues/493>)
  * Added ability to initialize parameter values in a node with an argument to the Node constructor. (#486 <https://github.com/ros2/rclcpp/issues/486>)
  * Added a ``Subscription`` tests which uses ``std::bind`` to a class member callback. (#480 <https://github.com/ros2/rclcpp/issues/480>)
  * Refactored the ``ParameterVariant`` class into the ``Parameter`` and ``ParameterValue`` classes. (#481 <https://github.com/ros2/rclcpp/issues/481>)
  * Relaxed template matching rules for ``std::bind`` and ``GNU C++ >= 7.1``. (#484 <https://github.com/ros2/rclcpp/issues/484>)
  * Changed to use the new ``rosgraph_msgs/Clock`` message type for the ``/clock`` topic. (#474 <https://github.com/ros2/rclcpp/issues/474>)
  * Fixed a flaky ROS time test due to not spinning before getting the time. (#483 <https://github.com/ros2/rclcpp/issues/483>)
  * Nodes now autostart the ROS parameter services which let you get, set, and list parameters in a node. (#478 <https://github.com/ros2/rclcpp/issues/478>)
  * Added support for arrays in Parameters. (#443 <https://github.com/ros2/rclcpp/issues/443>)
  * Changed how executors use ``AnyExecutable`` objects so that they are a reference instead of a shared pointer, in order to avoid memory allocation in the "common case". (#463 <https://github.com/ros2/rclcpp/issues/463>)
  * Added ability to pass command line arguments to the Node constructor. (#461 <https://github.com/ros2/rclcpp/issues/461>)
  * Added an argument to specify the number of threads a multithreaded executor should create. (#442 <https://github.com/ros2/rclcpp/issues/442>)
  * Changed library export order for static linking. (#446 <https://github.com/ros2/rclcpp/issues/446>)
  * Fixed some typos in the time unit tests. (#453 <https://github.com/ros2/rclcpp/issues/453>)
    Obviously it mean RCL_SYSTEM_TIME but not RCL_ROS_TIME in some test cases
    * Signed-off-by: jwang <mailto:jing.j.wang@intel.com>
  * Added the scale operation to ``rclcpp::Duration``.
    * Signed-off-by: jwang <mailto:jing.j.wang@intel.com>
  * Changed API of the log location parameter to be ``const``. (#451 <https://github.com/ros2/rclcpp/issues/451>)
  * Changed how the subscriber, client, service, and timer handles are stored to resolve shutdown order issues. (#431 <https://github.com/ros2/rclcpp/issues/431> and #448 <https://github.com/ros2/rclcpp/issues/448>)
  * Updated to get the node's logger name from ``rcl``. (#433 <https://github.com/ros2/rclcpp/issues/433>)
  * Now depends on ``ament_cmake_ros``. (#444 <https://github.com/ros2/rclcpp/issues/444>)
  * Updaed code to use logging macros rather than ``fprintf()``. (#439 <https://github.com/ros2/rclcpp/issues/439>)
  * Fixed a bug that was using an invalid iterator when erasing items using an iterator in a loop. (#436 <https://github.com/ros2/rclcpp/issues/436>)
  * Changed code to support move of ``rcutils_time_point_value_t`` type from ``uint64_t`` to ``int64_t``. (#429 <https://github.com/ros2/rclcpp/issues/429>)
  * Renamed parameter byte type to ``byte_values`` from ``bytes_value``. (#428 <https://github.com/ros2/rclcpp/issues/428>)
  * Changed executor code to clear the wait set before resizing and waiting. (#427 <https://github.com/ros2/rclcpp/issues/427>)
  * Fixed a potential dereference of nullptr in the topic name validation error string. (#405 <https://github.com/ros2/rclcpp/issues/405>)
    * Signed-off-by: Ethan Gao <mailto:ethan.gao@linux.intel.com>
  * Changed to use ``rcl_count_publishers()`` like API's rather than the lower level ``rmw_count_publishers()`` API. (#425 <https://github.com/ros2/rclcpp/issues/425>)
    * Signed-off-by: Sriram Raghunathan <mailto:rsriram7@visteon.com>
  * Fix potential segmentation fault due to ``get_topic_name()`` or ``rcl_service_get_service_name()`` returning nullptr and that not being checked before access in ``rclcpp``. (#426 <https://github.com/ros2/rclcpp/issues/426>)
    * Signed-off-by: Ethan Gao <mailto:ethan.gao@linux.intel.com>
  * Contributors: Denise Eng, Dirk Thomas, Ernesto Corbellini, Esteve Fernandez, Ethan Gao, Guillaume Autran, Karsten Knese, Matthew, Michael Carroll, Mikael Arguedas, Shane Loretz, Sriram Raghunathan, Tom Moore, William Woodall, dhood, jwang, jwang11, serge-nikulin

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Jun 2018 05:00:00 -0000


